import { IEffectsAction } from 'redux-effects-promise';
import { AnyT } from '../definitions.interface';
import { ISettings } from '../settings';
import { IStorage, ITransportResponseAccessor, IVersionProcessor } from '../definition';
import { IRoutesConfiguration } from '../configurations-definitions.interface';
import { BaseEffects } from '../store/effects/base.effects';
import { IUniversalStoreEntity } from '../entities-definitions.interface';
export declare class UniversalApplicationEffects<TApi> extends BaseEffects<TApi> {
    private static logger;
    protected readonly routes: IRoutesConfiguration;
    protected readonly settings: ISettings;
    protected notVersionedPersistentStorage: IStorage;
    protected responseAccessor: ITransportResponseAccessor;
    protected readonly versionProcessor: IVersionProcessor;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<IEffectsAction[]> | IEffectsAction[]}
     */
    $onInit(): Promise<IEffectsAction[]>;
    /**
     * @stable [16.09.2019]
     * @param {IEffectsAction} _
     * @param {IUniversalStoreEntity} state
     * @returns {Promise<IEffectsAction[]>}
     */
    $onAfterInit(_: IEffectsAction, state: IUniversalStoreEntity): Promise<IEffectsAction[]>;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    $onPrepare(): Promise<AnyT> | IEffectsAction[] | IEffectsAction;
    /**
     * @stable - 25.04.2018
     * @returns {Promise<AnyT> | IEffectsAction[] | IEffectsAction}
     */
    $onPrepareDone(action: IEffectsAction, state: IUniversalStoreEntity): Promise<AnyT> | IEffectsAction[] | IEffectsAction;
    /**
     * @stable [05.02.2019]
     * @param {IEffectsAction} action
     * @returns {IEffectsAction}
     */
    $onPrepareError(action: IEffectsAction): IEffectsAction;
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    $onAfterLogin(): IEffectsAction[];
    /**
     * @stable - 25.04.2018
     * @returns {IEffectsAction[]}
     */
    $onLogout(): IEffectsAction[];
    /**
     * @stable [16.09.2019]
     * @returns {Promise<IEffectsAction[]>}
     */
    $onAfterLogout(): Promise<IEffectsAction[]>;
    /**
     * @stable - 25.04.2018
     * @param {IEffectsAction} action
     * @param {IUniversalStoreEntity} state
     */
    $onAuthorized(action: IEffectsAction, state: IUniversalStoreEntity): Promise<void>;
    /**
     * @stable - 25.04.2018
     */
    $onUnauthorized(): Promise<void>;
    /**
     * @stable [16.09.2019]
     * @returns {Promise<void>}
     */
    protected processNewVersionAndReload(): Promise<void>;
}
