"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_dom_1 = require("react-dom");
var util_1 = require("../util");
var definition_1 = require("../definition");
var di_1 = require("../di");
var universal_bootstrap_app_factory_1 = require("./universal-bootstrap-app.factory");
/**
 * @stable [20.09.2019]
 * @param {IContainerClassEntity} applicationContainer
 * @param {IBootstrapEntity} bootstrapEntity
 */
exports.bootstrapReactApp = function (applicationContainer, bootstrapEntity) {
    if (bootstrapEntity === void 0) { bootstrapEntity = definition_1.DEFAULT_BOOTSTRAP_ENTITY; }
    var rootId = bootstrapEntity.rootId;
    var env = di_1.getEnvironment();
    if (bootstrapEntity.applyBodyMarkup) {
        util_1.addRootElement(rootId);
    }
    util_1.addClassNameToBody.apply(void 0, [env.appProfile].concat((bootstrapEntity.applyBodyMarkup ? ['rac'] : []), (bootstrapEntity.flexEnabled ? ['rac-flex'] : [])));
    var componentClass = universal_bootstrap_app_factory_1.makeBootstrapApp(applicationContainer, {}); // TODO Pass initial props
    react_dom_1.render(new componentClass({}).render(), // Isomorphic componentClass
    util_1.getElementById(rootId));
};
//# sourceMappingURL=react-app.bootstrapper.js.map