"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var application_interface_1 = require("./application.interface");
var ApplicationActionBuilder = /** @class */ (function () {
    function ApplicationActionBuilder() {
    }
    ApplicationActionBuilder.buildCustomErrorAction = function (error) {
        return redux_effects_promise_1.EffectsAction.create(this.buildCustomErrorActionType()).setError(error);
    };
    ApplicationActionBuilder.buildPrepareAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildPrepareActionType());
    };
    ApplicationActionBuilder.buildPrepareDoneAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildPrepareDoneActionType());
    };
    ApplicationActionBuilder.buildReadyAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildReadyActionType());
    };
    ApplicationActionBuilder.buildNotReadyAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildNotReadyActionType());
    };
    ApplicationActionBuilder.buildAfterLoginAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildAfterLoginActionType());
    };
    ApplicationActionBuilder.buildAuthorizedAction = function (payload) {
        return redux_effects_promise_1.EffectsAction.create(this.buildAuthorizedActionType(), payload);
    };
    ApplicationActionBuilder.buildUnauthorizedAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildUnauthorizedActionType());
    };
    ApplicationActionBuilder.buildAfterLogoutAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildAfterLogoutActionType());
    };
    ApplicationActionBuilder.buildAfterInitAction = function () {
        return redux_effects_promise_1.EffectsAction.create(this.buildAfterInitActionType());
    };
    ApplicationActionBuilder.buildReadyActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_READY_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildNotReadyActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_NOT_READY_ACTION_TYPE;
    };
    /**
     * @stable [23.10.2018]
     * @returns {string}
     */
    ApplicationActionBuilder.buildPathActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_PATH_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAuthorizedActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AUTHORIZED_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildUnauthorizedActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_UNAUTHORIZED_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildPrepareActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_PREPARE_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildPrepareDoneActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_PREPARE_DONE_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildPrepareErrorActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_PREPARE_ERROR_ACTION_TYPE;
    };
    /**
     * If there a chain of async tasks
     * @stable [31.07.2018]
     * @returns {string}
     */
    ApplicationActionBuilder.buildPrepareDoneErrorActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_PREPARE_DONE_ERROR_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildInitActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_INIT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAfterInitActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AFTER_INIT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildCustomErrorActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_CUSTOM_ERROR_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildLogoutActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_LOGOUT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildMountActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_MOUNT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAfterLogoutActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AFTER_LOGOUT_ACTION_TYPE;
    };
    ApplicationActionBuilder.buildAfterLoginActionType = function () {
        return application_interface_1.$APPLICATION_SECTION + "." + application_interface_1.APPLICATION_AFTER_LOGIN_ACTION_TYPE;
    };
    return ApplicationActionBuilder;
}());
exports.ApplicationActionBuilder = ApplicationActionBuilder;
//# sourceMappingURL=application-action.builder.js.map