/// <reference types="react" />
import { KeyPredicateT } from '../../util';
import { IApplicationContainerProps } from './application.interface';
import { IConnectorConfigEntity, IRouteConfigEntity } from '../../configurations-definitions.interface';
import { IContainerClassEntity, IStoreEntity } from '../../entities-definitions.interface';
import { UniversalApplicationContainer } from './universal-application.container';
export declare class ApplicationContainer<TStoreEntity extends IStoreEntity = IStoreEntity> extends UniversalApplicationContainer<IApplicationContainerProps> {
    private storage;
    private eventManager;
    constructor(props: IApplicationContainerProps);
    render(): JSX.Element;
    /**
     * @stable [19.05.2018]
     */
    componentDidMount(): void;
    /**
     * @stable [23.06.2018]
     */
    componentWillUnmount(): void;
    protected onUnload(): void;
    protected clearStateBeforeSerialization(state: TStoreEntity, ...predicates: KeyPredicateT[]): TStoreEntity;
    /**
     * @stable [02.07.2018]
     * @param {TStoreEntity} state
     */
    protected clearSystemState(state: TStoreEntity): void;
    protected getRoutes(): JSX.Element[];
    protected clearPreviousStates(): void;
    protected buildRoute(ctor: IContainerClassEntity, connectorConfiguration: IConnectorConfigEntity, cfg: IRouteConfigEntity): JSX.Element;
    /**
     * @stable [09.08.2019]
     */
    protected doSaveState(): void;
    private saveState;
    private readonly dynamicRouter;
}
