/// <reference types="react" />
import { IConnectorConfigEntity, IRouteConfigEntity } from '../../configurations-definitions.interface';
import { IContainerClassEntity } from '../../entities-definitions.interface';
import { UniversalContainer } from '../base/universal.container';
import { IUniversalApplicationContainerProps } from './universal-application.interface';
export declare type RoutePredicateT = (routeConfiguration: IRouteConfigEntity) => boolean;
export declare abstract class UniversalApplicationContainer<TProps extends IUniversalApplicationContainerProps> extends UniversalContainer<TProps> {
    static defaultProps: IUniversalApplicationContainerProps;
    private static logger;
    private extraRoutes;
    /**
     * @stable - 23.04.2018
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [19.05.2018]
     */
    componentDidMount(): void;
    /**
     * @stable - 23.04.2018
     * @param {RoutePredicateT} routePredicate
     * @returns {JSX.Element[]}
     */
    protected getRoutes(routePredicate?: RoutePredicateT): JSX.Element[];
    protected lookupConnectedContainerByRoutePath(path: string): IContainerClassEntity;
    protected registerRoute(container: IContainerClassEntity, config: IConnectorConfigEntity): void;
    protected registerLogoutRoute(): void;
    protected onBeforeLogout(): void;
    protected isMessageVisible(): boolean;
    protected getErrorMessage(): string;
    protected abstract buildRoute(ctor: IContainerClassEntity, connectorConfiguration: IConnectorConfigEntity, routeConfiguration: IRouteConfigEntity): JSX.Element;
    private buildRoutes;
}
