import * as React from 'react';
import { IBarcodeWrapper, IFilterWrapper, IFontSizeWrapper, IFooterWrapper, IFormatWrapper, IHeightWrapper } from '../../definitions.interface';
import { IComponentProps } from '../../props-definitions.interface';
/**
 * @stable [10.04.2019]
 */
export interface IBarcodeProps extends IComponentProps, IBarcodeWrapper, IHeightWrapper, IFilterWrapper<(barcode: BarcodeFormatEnum, barcodes: BarcodeFormatEnum[]) => boolean>, IFontSizeWrapper, IFooterWrapper<React.ReactNode | (() => React.ReactNode)>, IFormatWrapper<BarcodeFormatEnum[]> {
}
/**
 * @stable [10.04.2019]
 */
export declare enum BarcodeFormatEnum {
    EAN13 = "EAN13",
    EAN8 = "EAN8",
    CODE39 = "CODE39",
    UPC = "UPC"
}
/**
 * @stable [11.04.2019]
 */
export declare const BARCODE_APPLICABLE_FORMATS: BarcodeFormatEnum[];
