"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_1 = require("vue");
var vue_property_decorator_1 = require("vue-property-decorator");
var R = require("ramda");
var util_1 = require("../../util");
var di_1 = require("../../di");
var VueBaseComponent = /** @class */ (function (_super) {
    __extends(VueBaseComponent, _super);
    function VueBaseComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [19.11.2018]
     * @returns {boolean}
     */
    VueBaseComponent.prototype.isContainerBound = function () {
        return util_1.isDef(this.bindContainer);
    };
    /**
     * @stable [17.11.2018]
     * @returns {Element}
     */
    VueBaseComponent.prototype.getSelf = function () {
        return this.$refs.self;
    };
    /**
     * @stable [18.11.2018]
     * @returns {TState}
     */
    VueBaseComponent.prototype.getData = function () {
        return this.$data;
    };
    /**
     * @stable [26.11.2018]
     * @param {string} slotName
     * @returns {boolean}
     */
    VueBaseComponent.prototype.hasSlot = function (slotName) {
        return !R.isNil(Reflect.get(this.$slots, slotName));
    };
    /**
     * @stable [28.11.2018]
     * @param {number} index
     * @returns {IVueRefs}
     */
    VueBaseComponent.prototype.getChildrenRefs = function (index) {
        if (index === void 0) { index = 0; }
        return this.$children[index].$refs;
    };
    var _a;
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueBaseComponent.prototype, "className", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueBaseComponent.prototype, "full", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseComponent.prototype, "title", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Translate),
        __metadata("design:type", Function)
    ], VueBaseComponent.prototype, "t", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], VueBaseComponent.prototype, "settings", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.NumberConverter),
        __metadata("design:type", Object)
    ], VueBaseComponent.prototype, "nc", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueBaseComponent.prototype, "styles", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueBaseComponent.prototype, "bindContainer", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", typeof (_a = typeof TStore !== "undefined" && TStore) === "function" && _a || Object)
    ], VueBaseComponent.prototype, "bindStore", void 0);
    return VueBaseComponent;
}(vue_1.default));
exports.VueBaseComponent = VueBaseComponent;
//# sourceMappingURL=vue-base.component.js.map