"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../../util");
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @returns {boolean | undefined}
 */
exports.isButtonDisabled = function (entity) { return entity.disabled || entity.progress; };
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @param {IMessagesSettings} messages
 * @returns {string}
 */
exports.getButtonText = function (entity, messages) { return (entity.progress
    ? (entity.progressMessage || messages.waitingMessage)
    : util_1.orDefault(entity.error, function () { return entity.errorMessage || messages.defaultErrorMessage; }, entity.text)); };
/**
 * @stable - 19.04.2018
 * @param {UniversalButtonEntityT} entity
 * @param {string} progressIcon
 * @param {string} errorIcon
 * @returns {string}
 */
exports.getButtonIcon = function (entity, progressIcon, errorIcon) { return (entity.progress
    ? progressIcon
    : (entity.error ? errorIcon : entity.icon)); };
/**
 * @stable [23.02.2019]
 * @param {IGenericButtonEntity} props
 * @returns {boolean}
 */
exports.hasIconButton = function (props) { return !R.isNil(props.icon) && props.icon !== false; };
//# sourceMappingURL=button.support.js.map