"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../util");
var vue_index_1 = require("../connector/vue-index");
var vue_index_2 = require("../base/vue-index");
var VueButton = /** @class */ (function (_super) {
    __extends(VueButton, _super);
    function VueButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [11.11.2018]
     * @param {MouseEvent} event
     */
    VueButton.prototype.onClick = function (event) {
        this.$emit('click', event);
    };
    /**
     * @stable [27.12.2018]
     * @returns {string}
     */
    VueButton.prototype.getClassName = function () {
        return util_1.toClassName('vue-button', util_1.calc(this.className), this.disabled && 'vue-button-disabled');
    };
    /**
     * @stable [27.12.2018]
     * @returns {string}
     */
    VueButton.prototype.getText = function () {
        return this.progress ? this.t(this.settings.messages.waitingMessage) : this.t(this.text);
    };
    /**
     * @stable [21.01.2019]
     * @returns {string}
     */
    VueButton.prototype.getIconClassName = function () {
        return "vue-icon vue-icon-" + this.icon;
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueButton.prototype, "text", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueButton.prototype, "icon", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueButton.prototype, "disabled", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueButton.prototype, "progress", void 0);
    VueButton = __decorate([
        vue_index_1.ComponentName('vue-button'),
        vue_property_decorator_1.Component({
            template: "\n    <button :class=\"getClassName()\"\n            :disabled=\"disabled\"\n            v-on:click=\"onClick($event)\">\n      <vue-icon v-if=\"icon\"\n                :icon=\"icon\"/>\n      {{getText()}}\n    </button>\n  ",
        })
    ], VueButton);
    return VueButton;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-button.component.js.map