"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var chart_js_1 = require("chart.js");
var base_1 = require("../base");
var layout_1 = require("../layout");
var util_1 = require("../../util");
var Chart = /** @class */ (function (_super) {
    __extends(Chart, _super);
    function Chart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.canvasRef = React.createRef();
        return _this;
    }
    /**
     * @stable [28.02.2019]
     */
    Chart.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this.refresh();
    };
    /**
     * @stable [28.02.2019]
     * @param {Readonly<IChartProps>} prevProps
     * @param {Readonly<{}>} prevState
     */
    Chart.prototype.componentDidUpdate = function (prevProps, prevState) {
        _super.prototype.componentDidUpdate.call(this, prevProps, prevState);
        this.refresh();
    };
    /**
     * @stable [14.06.2018]
     * @returns {JSX.Element}
     */
    Chart.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return (React.createElement(layout_1.FlexLayout, { row: true, className: util_1.toClassName(props.className, 'rac-chart') },
            props.west,
            util_1.ifNotFalseThanValue(props.rendered, function () { return (React.createElement("div", { className: 'rac-chart-canvas-wrapper' },
                React.createElement("canvas", { ref: _this.canvasRef }))); }),
            props.east));
    };
    /**
     * @stable [28.02.2019]
     */
    Chart.prototype.refresh = function () {
        if (this.chartJs) {
            this.chartJs.destroy(); // It's too heavy to call an update() and update partially
        }
        var elId = this.canvasRef.current;
        if (!R.isNil(elId)) {
            this.chartJs = new chart_js_1.Chart(elId.getContext('2d'), this.props.options);
        }
    };
    return Chart;
}(base_1.BaseComponent));
exports.Chart = Chart;
//# sourceMappingURL=chart.component.js.map