import { ILayoutWrapperEntity, ITransportWrapperEntity, IUserWrapperEntity, INotificationWrapperEntity, IDictionariesWrapperEntity, IUniversalStoreEntity, IFilterFormWrapperEntity, IListAndFilterFormWrapperEntity } from '../../entities-definitions.interface';
import { IChannelWrapperEntity, IEditableEntity, IQueryFilterEntity, IQueryFilterWrapperEntity, IStackWrapperEntity } from '../../definition';
import { IFilterActionConfiguration, IFilterConfiguration } from '../../configurations-definitions.interface';
import { IKeyValue } from '../../definitions.interface';
export declare const layoutMapper: (state: ILayoutWrapperEntity) => ILayoutWrapperEntity;
export declare const filterMapper: (filterState: IQueryFilterEntity) => {
    filter: {
        active?: boolean;
        query?: string;
    };
};
export declare const notificationMapper: (state: INotificationWrapperEntity) => INotificationWrapperEntity;
export declare const channelMapper: (state: IChannelWrapperEntity) => IChannelWrapperEntity;
/**
 * @deprecated Use mapQueryFilterEntity
 */
export declare const filterWrapperMapper: (filterState: IQueryFilterWrapperEntity) => {
    filter: {
        active?: boolean;
        query?: string;
    };
};
/**
 * @stable [29.05.2018]
 * @param {IEditableEntity} editableEntity
 * @returns {IFilterActionConfiguration}
 */
export declare const activeClassNameEditableEntityMapper: (editableEntity: IEditableEntity<IKeyValue>) => IFilterActionConfiguration;
/**
 * @stable [29.05.2018]
 * @param {IFilterFormWrapperEntity} filterFormWrapperEntity
 * @returns {IFilterActionConfiguration}
 */
export declare const activeClassNameFilterFormWrapperEntityMapper: (filterFormWrapperEntity: IFilterFormWrapperEntity) => IFilterActionConfiguration;
/**
 * @stable [29.05.2018]
 * @param {IFilterFormWrapperEntity} filterFormWrapperEntity
 * @returns {IFilterActionConfiguration}
 */
export declare const openFilterFilterFormWrapperEntityMapper: (filterFormWrapperEntity: IFilterFormWrapperEntity) => IFilterActionConfiguration;
/**
 * @deprecated
 */
export declare const refreshListAndFilterFormWrapperEntityMapper: (mappedEntity: IListAndFilterFormWrapperEntity, actions?: IFilterActionConfiguration[]) => IFilterConfiguration;
/**
 * @stable [18.09.2018]
 * @param {IStackWrapperEntity} state
 * @returns {IStackWrapperEntity}
 */
export declare const stackMapper: (state: IStackWrapperEntity) => IStackWrapperEntity;
export declare const defaultMappers: (((storeEntity: IUniversalStoreEntity<{}, {}>) => IDictionariesWrapperEntity) | ((storeEntity: IUniversalStoreEntity<{}, {}>) => IUserWrapperEntity) | ((storeEntity: IUniversalStoreEntity<{}, {}>) => ITransportWrapperEntity) | ((state: ILayoutWrapperEntity) => ILayoutWrapperEntity) | ((state: INotificationWrapperEntity) => INotificationWrapperEntity) | ((state: IChannelWrapperEntity) => IChannelWrapperEntity) | ((state: IStackWrapperEntity) => IStackWrapperEntity))[];
