import { IBasicConnectorConfigEntity, IConnectorConfigEntity } from '../../configurations-definitions.interface';
import { IUniversalContainerClassEntity, IUniversalStoreEntity } from '../../entities-definitions.interface';
import { IUniversalContainerProps } from '../../definition';
/**
 * @stable - 23.04.2018
 * @param {IBasicConnectorConfigEntity<TStoreEntity>} config
 * @returns {(target: IContainerClassEntity) => void}
 */
export declare const basicConnector: <TStoreEntity extends IUniversalStoreEntity<{}, {}>>(config: IBasicConnectorConfigEntity<TStoreEntity>) => (target: IUniversalContainerClassEntity<IUniversalContainerProps, {}>) => void;
/**
 * @stable - 23.04.2018
 * @param {IConnectorConfigEntity<TStoreEntity extends IUniversalStoreEntity, TAccessConfig>} config
 * @returns {(target: IContainerClassEntity) => void}
 */
export declare const connector: <TStoreEntity extends IUniversalStoreEntity<{}, {}>, TAccessConfig>(config: IConnectorConfigEntity<TStoreEntity, TAccessConfig>) => (target: IUniversalContainerClassEntity<IUniversalContainerProps, {}>) => void;
