import { IActionsDisabledWrapper, IDisabledWrapper, IEntity, IEntityWrapper, IKeyValue } from '../../definitions.interface';
import { IEditableEntity, IEditableEntityFormWrapperEntity, IEntityFormEntity, IExtendedEntity, IPagedEntity, IPaginatedEntity, ITabPanelEntity, ITabPanelWrapperEntity, ToolbarToolsEnum } from '../../definition';
import { IOptionEntity, IListWrapperEntity, IListEntity, ITransportWrapperEntity, IUserWrapperEntity, IDictionariesWrapperEntity, IUniversalStoreEntity, IDataMutatorEntity, IDictionaryEntity, ISelectOptionEntity } from '../../entities-definitions.interface';
import { IFilterAndSorterConfiguration } from '../../configurations-definitions.interface';
export declare const dictionariesMapper: (storeEntity: IUniversalStoreEntity<{}, {}>) => IDictionariesWrapperEntity;
export declare const userMapper: (storeEntity: IUniversalStoreEntity<{}, {}>) => IUserWrapperEntity;
export declare const transportMapper: (storeEntity: IUniversalStoreEntity<{}, {}>) => ITransportWrapperEntity;
/**
 * @deprecated mapEditableEntity
 */
export declare const formMapper: (editableEntity: IEditableEntity<IKeyValue>) => IEditableEntityFormWrapperEntity<IKeyValue>;
/**
 * @stable [16.05.2018]
 * @param {IListEntity} listEntity
 * @param {IDataMutatorEntity} dataMutator
 * @returns {IListWrapperEntity}
 */
export declare const listMapper: (listEntity: IListEntity, dataMutator?: IDataMutatorEntity<IEntity>) => IListWrapperEntity;
/**
 * @deprecated (@see mapper.ts)
 * @param {IPaginatedEntity} entity
 * @returns {IPaginatedEntity}
 */
export declare const listEntityPaginatedEntityMapper: (entity: IPaginatedEntity) => IPaginatedEntity;
/**
 * @stable [09.05.2018]
 * @param {IListEntity} listEntity
 * @param {number} pageSize
 * @returns {IPagedEntity}
 */
export declare const listEntityPageEntityFilterMapper: (listEntity: IListEntity, pageSize?: number) => IPagedEntity;
/**
 * @deprecated
 */
export declare const listEntityWrapperPageEntityFilterMapper: (listEntity: IListWrapperEntity, pageSize?: number) => IPagedEntity;
/**
 * @stable [30.01.2019]
 * @param {IListWrapperEntity} listWrapperEntity
 * @returns {IListEntity}
 */
export declare const listSelector: (listWrapperEntity: IListWrapperEntity) => IListEntity;
/**
 * @deprecated Use mapListWrapperEntity
 */
export declare const listWrapperMapper: (listWrapperEntity: IListWrapperEntity, dataMutator?: IDataMutatorEntity<IEntity>) => IListWrapperEntity;
/**
 * @stable [31.08.2018]
 * @param {ITabPanelEntity} tabPanel
 * @returns {ITabPanelEntity}
 */
export declare const tabPanelMapper: (tabPanel: ITabPanelEntity) => ITabPanelWrapperEntity;
/**
 * @stable [30.08.2018]
 * @param {ITabPanelWrapperEntity} tabPanelWrapperEntity
 * @returns {ITabPanelWrapperEntity}
 */
export declare const tabPanelWrapperMapper: (tabPanelWrapperEntity: ITabPanelWrapperEntity) => ITabPanelWrapperEntity;
/**
 * @deprecated
 */
export declare const editableEntityChangesSelector: <TResult extends IEntity = IEntity>(entity: IEditableEntity<IKeyValue>) => TResult;
/**
 * @stable [17.01.2019]
 * @param {IEditableEntity} editableEntity
 * @returns {TResult}
 */
export declare const editableEntityChangesMapper: <TResult extends IEntity = IEntity>(editableEntity: IEditableEntity<IKeyValue>) => TResult;
/**
 * @deprecated
 */
export declare const entityMapper: <TEntity extends IEntity>(entity: TEntity, editableEntity?: IEditableEntity<IKeyValue>) => IExtendedEntity<TEntity>;
/**
 * @deprecated
 */
export declare const selectedEntitySelector: <TEntity extends IEntity>(listEntity: IListEntity) => TEntity;
/**
 * @deprecated
 */
export declare const listSelectedEntitySelector: <TEntity extends IEntity>(listWrapperEntity: IListWrapperEntity) => TEntity;
/**
 * @deprecated Use mapListSelectedExtendedEntity
 */
export declare const listWrapperSelectedEntityMapper: <TEntity extends IEntity>(listWrapperState: IListWrapperEntity, formEntity?: IEditableEntity<IKeyValue>) => IEntityWrapper<TEntity>;
/**
 * @stable [19.12.2018]
 * @param {IListEntity} listEntity
 * @returns {IDisabledWrapper}
 */
export declare const disabledListEntityMapper: (listEntity: IListEntity) => IDisabledWrapper<boolean>;
/**
 * @deprecated
 */
export declare const actionsDisabledListEntityMapper: (listEntity: IListEntity) => IActionsDisabledWrapper;
/**
 * @deprecated mapListWrapperActionsDisabled
 */
export declare const actionsDisabledListWrapperEntityMapper: (listWrapperEntity: IListWrapperEntity) => IActionsDisabledWrapper;
/**
 * @deprecated selectEditableEntityToolbarToolsFilter
 */
export declare const toolbarActiveFilterToolEditableEntityMapper: (editableEntity: IEditableEntity<IKeyValue>) => ToolbarToolsEnum[];
/**
 * @deprecated selectFormEntityToolbarToolsFilter
 */
export declare const toolbarActiveFilterToolFormWrapperEntityMapper: (entityFormEntity: IEntityFormEntity<IEntity>) => ToolbarToolsEnum[];
/**
 * @stable [19.12.2018]
 * @param {IListWrapperEntity} listWrapperEntity
 * @returns {IDisabledWrapper}
 */
export declare const disabledListWrapperEntityMapper: (listWrapperEntity: IListWrapperEntity) => IDisabledWrapper<boolean>;
/**
 * @stable [31.08.2018]
 * @param {TEntity[] | TEntity} data
 * @param {IFilterAndSorterConfiguration} config
 * @returns {Array<ISelectOptionEntity<TEntity extends IOptionEntity>>}
 */
export declare const selectOptionsMapper: <TEntity extends IOptionEntity>(data: TEntity | TEntity[], config?: IFilterAndSorterConfiguration) => ISelectOptionEntity<TEntity>[];
/**
 * @stable [16.06.2018]
 * @param {IDictionaryEntity<TDictionaryEntity>} dictionaryEntity
 * @param {IFilterAndSorterConfiguration} config
 * @returns {Array<ISelectOptionEntity<TDictionaryEntity>>}
 */
export declare const dictionaryEntityMapper: <TDictionaryEntity>(dictionaryEntity: IDictionaryEntity<TDictionaryEntity>, config?: IFilterAndSorterConfiguration) => ISelectOptionEntity<TDictionaryEntity>[];
/**
 * @stable [20.12.2018]
 * @param {IDictionaryEntity<TDictionaryEntity>} dictionaryEntity
 * @param {(data: (TDictionaryEntity[] | TDictionaryEntity)) => TResult} accessor
 * @returns {TResult}
 */
export declare const dictionaryEntityDataMapper: <TDictionaryEntity, TResult = TDictionaryEntity | TDictionaryEntity[]>(dictionaryEntity: IDictionaryEntity<TDictionaryEntity>, accessor?: (data: TDictionaryEntity | TDictionaryEntity[]) => TResult) => TResult;
/**
 * @stable [29.05.2018]
 */
export declare const universalDefaultMappers: (((storeEntity: IUniversalStoreEntity<{}, {}>) => IDictionariesWrapperEntity) | ((storeEntity: IUniversalStoreEntity<{}, {}>) => IUserWrapperEntity) | ((storeEntity: IUniversalStoreEntity<{}, {}>) => ITransportWrapperEntity))[];
