/// <reference types="react" />
import { AnyT, IKeyboardEvent, IChangeEvent, IFocusEvent, IJQueryInputElement } from '../../../definitions.interface';
import { IField, IFieldInputProps, IFieldInternalProps, IFieldState, IFieldTextAreaProps } from './field.interface';
import { UniversalField } from './universal-field.component';
import { IBaseEvent } from '../../../definition';
export declare class Field<TInternalProps extends IFieldInternalProps, TState extends IFieldState = IFieldState> extends UniversalField<TInternalProps, TState, IKeyboardEvent, IFocusEvent, IBaseEvent> implements IField<TInternalProps, TState> {
    /**
     * @stable [26.05.2019]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [07.01.2019]
     * @param {AnyT} currentRawValue
     */
    onChangeManually(currentRawValue: AnyT): void;
    /**
     * @stable [18.06.2018]
     * @param {IChangeEvent} event
     * @returns {AnyT}
     */
    getRawValueFromEvent(event: IChangeEvent): AnyT;
    /**
     * @stable [17.06.2018]
     */
    resetError(): void;
    /**
     * @stable [03.09.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyDown(event: IKeyboardEvent): void;
    /**
     * @stable [20.08.2018]
     */
    setFocus(): void;
    /**
     * @stable [05.10.2018]
     * @returns {HTMLInputElement | HTMLTextAreaElement}
     */
    readonly input: HTMLInputElement | HTMLTextAreaElement;
    protected getSelfElement(): JSX.Element;
    protected getInputWrapperElement(): JSX.Element;
    protected getProgressLabelElement(): JSX.Element;
    protected readonly actionsElement: JSX.Element;
    protected getLabelElement(): JSX.Element;
    protected getMirrorInputElement(): JSX.Element;
    protected getInputCaretElement(): JSX.Element;
    protected getPrefixLabelElement(): JSX.Element;
    protected getAttachmentElement(): JSX.Element;
    /**
     * @stable [05.10.2018]
     * @returns {boolean}
     */
    protected readonly hasInput: boolean;
    /**
     * @stable [20.08.2018]
     */
    protected removeFocus(): void;
    /**
     * @stable [30.10.2018]
     * @param {IFocusEvent} event
     */
    protected onBlur(event: IFocusEvent): void;
    /**
     * @stable [30.10.2018]
     * @param {IFocusEvent} event
     */
    protected onFocus(event: IFocusEvent): void;
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    protected getInputElement(): JSX.Element;
    protected getInputElementProps(): IFieldInputProps | IFieldTextAreaProps;
    /**
     * @stable [18.06.2018]
     * @param {IBaseEvent} event
     */
    protected onClick(event: IBaseEvent): void;
    /**
     * @stable [06.10.2018]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [03.09.2018]
     * @returns {boolean}
     */
    protected hasInputFocus(): boolean;
    /**
     * @stable [31.05.2019]
     * @returns {string}
     */
    protected getInputWrapperElementClassName(): string;
    /**
     * stable [18.06.2018]
     * @returns {string}
     */
    protected getSelfElementClassName(): string;
    /**
     * @stable [31.07.2018]
     * @returns {boolean}
     */
    protected isInputValid(): boolean;
    /**
     * @stable [31.07.2018]
     * @returns {string}
     */
    protected getNativeInputValidationMessage(): string;
    /**
     * @stable [31.07.2018]
     * @param {string} error
     */
    protected setNativeInputValidity(error: string): void;
    /**
     * @stable [03.09.2018]
     * @param {string} message
     * @param {string} className
     * @returns {JSX.Element}
     */
    protected toMessageElement(message: string, className?: string): JSX.Element;
    /**
     * @stable [17.06.2018]
     * @param {AnyT} value
     */
    private updateInputBeforeHTML5Validation;
    /**
     * TODO domAccessor
     */
    protected readonly jqInput: IJQueryInputElement;
}
