"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var field_support_1 = require("./field.support");
var definition_1 = require("../../../definition");
describe('field.support', function () {
    describe('toActualChangedValue', function () {
        it('test1', function () {
            var actualChangedValue = field_support_1.toActualChangedValue({
                value: [],
                emptyValue: [],
                originalValue: definition_1.FIELD_VALUE_TO_CLEAR_DIRTY_CHANGES,
            });
            expect(actualChangedValue).toEqual(definition_1.FIELD_VALUE_TO_CLEAR_DIRTY_CHANGES);
        });
        it('test2', function () {
            var actualChangedValue = field_support_1.toActualChangedValue({
                value: [1, 2, 3],
                emptyValue: [],
                originalValue: [1, 2],
            });
            expect(actualChangedValue).toEqual([1, 2, 3]);
        });
        it('test3', function () {
            var actualChangedValue = field_support_1.toActualChangedValue({
                value: [1, 2],
                emptyValue: [],
                originalValue: [1, 2],
            });
            expect(actualChangedValue).toEqual(definition_1.FIELD_VALUE_TO_CLEAR_DIRTY_CHANGES);
        });
        it('test4', function () {
            var actualChangedValue = field_support_1.toActualChangedValue({
                value: 'test1',
                emptyValue: '',
                originalValue: 'test',
            });
            expect(actualChangedValue).toEqual('test1');
        });
        it('test5', function () {
            var actualChangedValue = field_support_1.toActualChangedValue({
                value: 'test',
                emptyValue: '',
                originalValue: 'test',
            });
            expect(actualChangedValue).toEqual(definition_1.FIELD_VALUE_TO_CLEAR_DIRTY_CHANGES);
        });
    });
});
//# sourceMappingURL=field.support.spec.js.map