/// <reference types="react" />
import { ILogger } from 'ts-smart-logger';
import { BaseTextField } from '../textfield';
import { EntityIdT, IKeyboardEvent, AnyT } from '../../../definitions.interface';
import { MultiFieldPlugin } from '../multifield';
import { IBaseFileFieldState, IBaseFileFieldProps } from './basic-filefield.interface';
import { IBaseEvent } from '../../../definition';
export declare class BaseFileField<TProps extends IBaseFileFieldProps, TState extends IBaseFileFieldState> extends BaseTextField<TProps, TState> {
    protected static readonly logger: ILogger;
    protected multiFieldPlugin: MultiFieldPlugin;
    /**
     * @stable [30.06.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [28.06.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyEnter(event: IKeyboardEvent): void;
    /**
     * @stable [28.06.2018]
     * @param {IKeyboardEvent} event
     */
    onKeyBackspace(event: IKeyboardEvent): void;
    clearValue(): void;
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    protected onClick(event: IBaseEvent): void;
    /**
     * @stable [03.08.2018]
     * @returns {JSX.Element}
     */
    protected getAttachmentElement(): JSX.Element;
    /**
     * @stable [02.08.2018]
     * @returns {EntityIdT[]}
     */
    protected getEmptyValue(): EntityIdT[];
    /**
     * @stable [05.10.2018]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     * @stable [14.01.2019]
     * @param {AnyT} value
     * @returns {string}
     */
    protected decorateValueBeforeDisplaying(value: AnyT): string;
    /**
     * @stable [02.08.2018]
     */
    private onCameraDialogClose;
    /**
     * @stable [02.08.2018]
     */
    private onCameraDialogAccept;
    /**
     * @stable [19.12.2018]
     * @param {Blob[]} file
     */
    private onSelect;
    /**
     * @stable [02.08.2018]
     * @param {Blob} blob
     */
    private doSelectBlob;
    /**
     * @stable [01.08.2019]
     * @param {Blob} blob
     */
    private onSelectCameraSnapshot;
    private readonly dnd;
    /**
     * @stable [02.08.2018]
     * @param {IBaseEvent} event
     */
    private openCameraDialog;
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    private openFileDialog;
    /**
     * @stable [28.06.2018]
     * @param {IBaseEvent} event
     */
    private downloadFile;
    /**
     * @stable [02.08.2018]
     * @returns {IUniversalDialog}
     */
    private readonly cameraDialog;
    /**
     * @stable [02.08.2018]
     * @returns {IWebCamera}
     */
    private readonly camera;
}
