"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../field/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var vue_index_3 = require("../../viewer/vue-index");
var VueBaseFileField = /** @class */ (function (_super) {
    __extends(VueBaseFileField, _super);
    /**
     * @stable [27.11.2018]
     */
    function VueBaseFileField() {
        var _this = _super.call(this) || this;
        _this.multiFieldPlugin = new vue_index_2.MultiFieldPlugin(_this);
        _this.cachedFiles = new Map();
        _this.onFileChange = _this.onFileChange.bind(_this);
        _this.onFilesSelect = _this.onFilesSelect.bind(_this);
        _this.getViewerBindings = _this.getViewerBindings.bind(_this);
        _this.getViewerListeners = _this.getViewerListeners.bind(_this);
        _this.getViewerComponent = _this.getViewerComponent.bind(_this);
        _this.getDefaultDndMessage = _this.getDefaultDndMessage.bind(_this);
        _this.getCustomDndMessage = _this.getCustomDndMessage.bind(_this);
        _this.getPlaceholder = _this.getPlaceholder.bind(_this);
        _this.getEntities = _this.getEntities.bind(_this);
        _this.getAttachmentContentClassName = _this.getAttachmentContentClassName.bind(_this);
        _this.canRenderAttachmentContent = _this.canRenderAttachmentContent.bind(_this);
        return _this;
    }
    /**
     * @stable [25.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldClassName = function () {
        return _super.prototype.getFieldClassName.call(this) + " vue-file-field";
    };
    /**
     * @stable [11.02.2019]
     * @param {File[]} files
     * @param {IMultiItemFileEntity | IEntity} replacedEntity
     * @param {number} index
     */
    VueBaseFileField.prototype.onFilesSelect = function (files, replacedEntity, index) {
        var _this = this;
        Array.from(files).forEach(function (file) {
            var url = _this.toFileUrl(file);
            if (R.isNil(replacedEntity)) {
                _this.addFile(file, url, index);
            }
            else {
                _this.replaceFile(replacedEntity, file, url, index);
            }
        });
        if (this.openViewerPopupOnFileSelect) {
            // Need to open popup after selecting/change
            this.openViewerPopup();
        }
    };
    /**
     * @stable [12.02.2019]
     * @param {IMultiItemFileEntity | IEntity} entity
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getDefaultDndMessage = function (entity, index) {
        return util_1.nvl(this.defaultDndMessage, this.settings.messages.dndMessage);
    };
    /**
     * @stable [12.02.2019]
     * @param {IMultiItemFileEntity | IEntity} entity
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getCustomDndMessage = function (entity, index) {
        var _this = this;
        return util_1.ifNotNilThanValue(this.defaultDndMessageFactory, function () { return _this.defaultDndMessageFactory(index); });
    };
    /**
     * [<Placeholder: optional> + <Default DnD message>]
     *
     * @stable [22.12.2018]
     * @param {MultiItemEntityT} entityOrEntityId
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getPlaceholder = function (entityOrEntityId, index) {
        return util_1.isFn(this.placeholderFactory)
            ? this.placeholderFactory(index)
            : this.t(this.placeholder);
    };
    /**
     * @stable [20.12.2018]
     * @returns {IEntity[]}
     */
    VueBaseFileField.prototype.getEntities = function () {
        return [];
    };
    /**
     * @stable [11.02.2019]
     * @param {IMultiItemFileEntity | IEntity} entity
     * @param {number} index
     * @returns {boolean}
     */
    VueBaseFileField.prototype.canRenderAttachmentContent = function (entity, index) {
        return util_1.isFn(this.canRenderAttachment) ? this.canRenderAttachment(entity, index) : R.isNil(entity);
    };
    /**
     * @stable [22.12.2018]
     * @param {MultiItemEntityT} entityOrEntityId
     * @param {number} index
     * @returns {IVueBaseFileViewerProps}
     */
    VueBaseFileField.prototype.getViewerBindings = function (entityOrEntityId, index) {
        var _this = this;
        var viewerProps = this.viewerProps;
        var multiItemEntity = entityOrEntityId;
        var props = __assign({}, viewerProps, { placeholder: this.getPlaceholder(entityOrEntityId, index), className: util_1.toClassName(this.toAttachmentContentClassName(entityOrEntityId, index), viewerProps && util_1.calc(viewerProps.className, multiItemEntity)) });
        if (util_1.isPrimitive(entityOrEntityId)) {
            // In case of a single field which receives only entity id
            return __assign({}, props, { src: this.getDisplayValue() || entityOrEntityId, fileName: this.getFileName() });
        }
        else if (multiItemEntity.newEntity) {
            var relationId_1 = multiItemEntity.id;
            return util_1.defValuesFilter(__assign({}, props, { src: relationId_1, fileName: util_1.orUndef(this.cachedFiles.has(relationId_1), function () { return _this.cachedFiles.get(relationId_1).name; }) }));
        }
        return __assign({}, props, { src: Reflect.get(multiItemEntity, this.displayName), entity: multiItemEntity });
    };
    /**
     * @stable [16.12.2018]
     * @param {MultiItemEntityT} entityOrEntityId
     * @param {number} index
     * @returns {IVueViewerListenersEntity<File>}
     */
    VueBaseFileField.prototype.getViewerListeners = function (entityOrEntityId, index) {
        var _this = this;
        return {
            change: function (file) { return _this.onFileChange(entityOrEntityId, file, index); },
            remove: function () { return _this.removeFile(entityOrEntityId); },
        };
    };
    /**
     * @stable [21.12.2018]
     * @param {File} file
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getViewerComponent = function (file, index) {
        return this.viewer;
    };
    /**
     * @stable [11.02.2019]
     * @param {MultiItemEntityT} entityOrEntityId
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getAttachmentContentClassName = function (entityOrEntityId, index) {
        return util_1.toClassName(this.toAttachmentContentClassName(entityOrEntityId, index), !R.isNil(entityOrEntityId) && 'vue-field-attachment-content-with-entity');
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getInputClassName = function () {
        return _super.prototype.getInputClassName.call(this) + " rac-flex-full";
    };
    /**
     * @stable [09.12.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldAttachmentTemplate = function () {
        return ("<div class=\"vue-field-attachment-wrapper\">\n          <div v-for=\"(entity, index) in getEntities()\"\n               class=\"vue-field-attachment-holder\">\n            <component v-if=\"entity\"\n                       ref=\"viewerRef\"\n                       :is=\"getViewerComponent(entity, index)\"\n                       v-on=\"getViewerListeners(entity, index)\"\n                       v-bind=\"getViewerBindings(entity, index)\"/>\n            <vue-flex-layout v-if=\"canRenderAttachmentContent(entity, index)\"\n                             :row=\"true\"\n                             :class=\"getAttachmentContentClassName(entity, index)\">\n                <vue-flex-layout v-if=\"getPlaceholder(entity, index)\"\n                                :justifyContentCenter=\"true\"\n                                :class=\"'vue-field-attachment-placeholder vue-field-attachment-placeholder-' + index\">\n                    {{getPlaceholder(entity, index)}}\n                </vue-flex-layout>\n                <vue-flex-layout :class=\"'vue-field-attachment-dnd-message vue-field-attachment-dnd-message-' + index\"\n                                 :full=\"!getPlaceholder(entity, index)\">\n                    <vue-dnd :defaultMessage=\"getDefaultDndMessage(entity, index)\"\n                             :customMessage=\"getCustomDndMessage(entity, index)\"\n                             @select=\"onFilesSelect($event, entity, index)\"/>\n                </vue-flex-layout>\n            </vue-flex-layout>\n          </div>\n       </div>");
    };
    /**
     * @stable [10.12.2018]
     * @returns {TMethods}
     */
    VueBaseFileField.prototype.getTemplateMethods = function () {
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { onFilesSelect: this.onFilesSelect, getEntities: this.getEntities, getDefaultDndMessage: this.getDefaultDndMessage, getCustomDndMessage: this.getCustomDndMessage, getAttachmentContentClassName: this.getAttachmentContentClassName, getPlaceholder: this.getPlaceholder, getViewerComponent: this.getViewerComponent, getViewerListeners: this.getViewerListeners, getViewerBindings: this.getViewerBindings, canRenderAttachmentContent: this.canRenderAttachmentContent });
    };
    VueBaseFileField.prototype.getFileFormat = function () {
        var fileFormatValue;
        return util_1.isDef(this.bindStore) && !R.isNil(fileFormatValue = this.bindStore[this.displayFileFormat])
            ? fileFormatValue
            : this.getValue();
    };
    /**
     * @stable [19.01.2019]
     * @param {string} type
     * @returns {string}
     */
    VueBaseFileField.prototype.toViewer = function (type) {
        switch (type) {
            case 'application/pdf':
                return vue_index_3.VUE_PDF_FILE_VIEWER_NAME;
        }
        return this.viewer;
    };
    /**
     * @stable [10.12.2018]
     * @param {File} file
     * @returns {string}
     */
    VueBaseFileField.prototype.toFileUrl = function (file) {
        var newFileUrl = URL.createObjectURL(file);
        this.cachedFiles.set(newFileUrl, file);
        return newFileUrl;
    };
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.destroyFileUrl = function (fileUrl) {
        this.cachedFiles.delete(fileUrl);
        URL.revokeObjectURL(fileUrl);
    };
    /**
     * @stable [27.02.2019]
     * @param {IMultiItemFileEntity | IEntity} entity
     * @param {File} file
     * @param {number} index
     */
    VueBaseFileField.prototype.onFileChange = function (entity, file, index) {
        var newFileUrl = this.toFileUrl(file);
        if (entity.newEntity) {
            this.replaceFile(entity, file, newFileUrl, index);
        }
        else {
            this.editFile(entity, file, newFileUrl, index);
        }
    };
    VueBaseFileField.prototype.getFileName = function () {
        var fileNameValue;
        return util_1.isDef(this.bindStore) && !R.isNil(fileNameValue = this.bindStore[this.displayFileName])
            ? fileNameValue
            : this.getValue();
    };
    /**
     * @stable [11.02.2019]
     * @param {MultiItemEntityT} entityOrEntityId
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.toAttachmentContentClassName = function (entityOrEntityId, index) {
        return util_1.toClassName('vue-field-attachment-content', this.getPlaceholder(entityOrEntityId, index) && ' vue-field-attachment-content-with-placeholder');
    };
    /**
     * @stable [27.02.2019]
     * @param {IMultiItemFileEntity} entity
     * @param {File} file
     * @param {string} fileUrl
     * @param {number} index
     */
    VueBaseFileField.prototype.replaceFile = function (entity, file, fileUrl, index) {
        var _this = this;
        this.removeFile(entity);
        this.$nextTick(function () { return _this.addFile(file, fileUrl, index); }); // Next tick <=> Flux Cycle
    };
    /**
     * @stable [27.02.2019]
     * @param {File} file
     * @param {string} fileUrl
     * @param {number} index
     */
    VueBaseFileField.prototype.addFile = function (file, fileUrl, index) {
        this.multiFieldPlugin.onAddItem({
            id: fileUrl,
            rawData: util_1.toType({
                id: fileUrl,
                newEntity: true,
                type: file.type,
                name: file.name,
                index: index,
            }),
        });
    };
    /**
     * @stable [27.02.2019]
     * @param {IMultiItemFileEntity} entity
     * @param {File} file
     * @param {string} fileUrl
     * @param {number} index
     */
    VueBaseFileField.prototype.editFile = function (entity, file, fileUrl, index) {
        this.multiFieldPlugin.onEditItem({
            id: entity.id,
            name: this.displayName,
            value: fileUrl,
            index: index,
        });
    };
    /**
     * @stable [11.02.2019]
     * @param {IMultiItemFileEntity | IEntity | EntityIdT} entity
     */
    VueBaseFileField.prototype.removeFile = function (entity) {
        var url;
        var deletedEntity;
        if (util_1.isPrimitive(entity)) {
            var fileId = entity;
            deletedEntity = { id: fileId };
            url = fileId;
        }
        else {
            var multiItemEntity = entity;
            deletedEntity = multiItemEntity;
            url = multiItemEntity.id;
        }
        this.multiFieldPlugin.onDeleteItem(deletedEntity);
        this.destroyFileUrl(url);
    };
    /**
     * @stable [27.02.2019]
     */
    VueBaseFileField.prototype.openViewerPopup = function () {
        var _this = this;
        this.$nextTick(function () {
            var viewer = _this.getChildrenRefs().viewerRef[0];
            if (!R.isNil(viewer)) {
                viewer.onOpenPopup();
            }
        });
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "displayFileName", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "displayFileFormat", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "placeholderFactory", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "canRenderAttachment", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 1; } }),
        __metadata("design:type", Number)
    ], VueBaseFileField.prototype, "maxFiles", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return false; } }),
        __metadata("design:type", Boolean)
    ], VueBaseFileField.prototype, "openViewerPopupOnFileSelect", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "defaultDndMessage", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "defaultDndMessageFactory", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return vue_index_3.VUE_FILE_VIEWER_NAME; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "viewer", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'hidden'; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "type", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueBaseFileField.prototype, "viewerProps", void 0);
    return VueBaseFileField;
}(vue_index_1.VueField));
exports.VueBaseFileField = VueBaseFileField;
//# sourceMappingURL=vue-base-filefield.component.js.map