/// <reference types="react" />
import { ILogger } from 'ts-smart-logger';
import { BaseTextField } from '../../field/textfield';
import { AnyT, IKeyboardEvent } from '../../../definitions.interface';
import { ISelectOptionEntity } from '../../../entities-definitions.interface';
import { IBaseSelectProps, IBasicSelectState } from './basic-select.interface';
import { IBaseEvent } from '../../../definition';
export declare class BasicSelect<TProps extends IBaseSelectProps, TState extends IBasicSelectState> extends BaseTextField<TProps, TState> {
    protected static logger: ILogger;
    /**
     * @stable [15.09.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [20.08.2018]
     * @param {Readonly<TProps extends IBaseSelectProps>} prevProps
     * @param {Readonly<TState extends IBasicSelectState>} prevState
     */
    componentDidUpdate(prevProps: Readonly<TProps>, prevState: Readonly<TState>): void;
    onKeyDown(event: IKeyboardEvent): void;
    onKeyBackspace(event: IKeyboardEvent): void;
    onKeyEnter(event: IKeyboardEvent): void;
    onKeyEscape(event: IKeyboardEvent): void;
    /**
     * @stable [06.10.2018]
     */
    clearValue(): void;
    /**
     * @stable [25.02.2019]
     * @param {IBaseEvent} event
     */
    openMenu(event?: IBaseEvent): void;
    /**
     * @stable [18.06.2018]
     * @returns {boolean}
     */
    inProgress(): boolean;
    /**
     * @stable [25.02.2019]
     * @param {IBaseEvent} event
     */
    protected onClick(event: IBaseEvent): void;
    /**
     * @stable [01.06.2018]
     * @returns {JSX.Element}
     */
    protected getInputAttachmentElement(): JSX.Element;
    /**
     * @stable [06.10.2018]
     * @returns {string}
     */
    protected getInputWrapperElementClassName(): string;
    /**
     * @stable [20.08.2018]
     * @returns {ISelectOptionEntity[]}
     */
    protected toFilteredOptions(): ISelectOptionEntity[];
    /**
     * @stable [29.06.2018]
     * @returns {AnyT}
     */
    protected getEmptyValue(): AnyT;
    /**
     * @stable [20.08.2018]
     * @param {ISelectOptionEntity} option
     */
    protected onSelect(option: ISelectOptionEntity): void;
    /**
     * @stable [10.09.2019]
     */
    protected onClose(): void;
    /**
     * @stable [12.02.2019]
     * @param {AnyT} value
     * @returns {AnyT}
     */
    protected getDecoratedValue(value: AnyT): AnyT;
    /**
     * @stable [20.08.2018]
     * @returns {ISelectOptionEntity[]}
     */
    protected readonly options: ISelectOptionEntity[];
    /**
     * @stable [20.08.2018]
     * @returns {IMenu}
     */
    private readonly menu;
    /**
     * @stable [20.08.2018]
     */
    private showMenu;
    /**
     * @stable [20.08.2018]
     */
    private hideMenu;
    private onFilterChange;
}
