/// <reference types="react" />
import { IEventManager } from '../../../event';
import { IFieldActionConfiguration, IKeyboardConfiguration } from '../../../configurations-definitions.interface';
import { Field } from '../field';
import { IBaseTextFieldState, IBaseTextFieldProps, IBaseTextField } from './base-textfield.interface';
export declare class BaseTextField<TProps extends IBaseTextFieldProps, TState extends IBaseTextFieldState> extends Field<TProps, TState> implements IBaseTextField<TProps, TState> {
    private static readonly DEFAULT_MASK_GUIDE;
    protected eventManager: IEventManager;
    protected defaultActions: IFieldActionConfiguration[];
    private environment;
    private readonly mirrorInputRef;
    private readonly keyboardRef;
    private keyboardListenerSubscriber;
    /**
     * @stable [25.02.2019]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    protected getInputElement(): JSX.Element;
    /**
     * @stable [07.11.2018]
     * @returns {string}
     */
    protected getSelfElementClassName(): string;
    protected addClearAction(): void;
    /**
     * @stable [03.09.2018]
     * @returns {JSX.Element}
     */
    protected keyboardElement(): JSX.Element;
    /**
     * @stable [13.01.2019]
     * @returns {boolean}
     */
    protected isKeyboardOpened(): boolean;
    /**
     * @stable [21.11.2018]
     * @returns {IKeyboardConfiguration}
     */
    protected getKeyboardConfiguration(): IKeyboardConfiguration;
    /**
     * @stable [23.02.2019]
     */
    protected openSyntheticKeyboard(): boolean;
    /**
     * @stable [23.02.2019]
     */
    protected onCloseKeyboard(): void;
    /**
     * @stable [04.09.2018]
     */
    protected refreshCaretPosition(): void;
    /**
     * @stable [04.09.2018]
     * @returns {number}
     */
    protected getCaretPosition(): number;
    /**
     * @stable [21.09.2018]
     * @returns {string}
     */
    protected getFieldClassName(): string;
    /**
     *
     * @returns {JSX.Element}
     */
    protected getProgressLabelElement(): JSX.Element;
    /**
     * @stable [12.09.2018]
     * @returns {JSX.Element}
     */
    protected getMirrorInputElement(): JSX.Element;
    /**
     * @stable [04.09.2018]
     * @returns {JSX.Element}
     */
    protected getInputCaretElement(): JSX.Element;
    /**
     * @stable [15.09.2018]
     * @returns {JSX.Element}
     */
    protected getPrefixLabelElement(): JSX.Element;
    /**
     * @stable [16.02.2019]
     * @param {IBaseEvent} e
     */
    private onDocumentClickHandler;
    private readonly actions;
    /**
     * @stable [04.09.2018]
     * @param {string} rawValue
     */
    private onKeyboardChange;
    /**
     * TODO domAccessor
     */
    private readonly jMirrorInput;
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    private getMaskedInputElement;
    /**
     * @stable [24.05.2019]
     * @returns {JSX.Element}
     */
    protected readonly actionsElement: JSX.Element;
}
