/// <reference types="react" />
import { IApiEntity } from '../../definition';
import { BaseComponent } from '../base';
import { IForm, IFormProps } from './form.interface';
export declare class Form extends BaseComponent<IFormProps> implements IForm {
    static defaultProps: IFormProps;
    private static logger;
    private fieldsOptions;
    private readonly childrenMap;
    /**
     * @stable [29.05.2018]
     * @param {IFormProps} props
     */
    constructor(props: IFormProps);
    render(): JSX.Element;
    /**
     * @stable [12.09.2018]
     */
    componentDidMount(): void;
    componentWillUnmount(): void;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    isFormValid(): boolean;
    /**
     * @stable - 11.04.2018
     * @param {IApiEntity} apiEntity
     */
    submit(apiEntity: IApiEntity): void;
    /**
     * @stable - 11.04.2018
     * @returns {IApiEntity}
     */
    readonly apiEntity: IApiEntity;
    /**
     * @stable [25.02.2019]
     * @returns {string}
     */
    private getFormClassName;
    private onChange;
    /**
     * @stable [04.08.2018]
     * @param {IField} field
     */
    private onEmptyDictionary;
    private onLoadDictionary;
    private propsOnValid;
    private onSubmit;
    private onReset;
    private resetGroupFieldsErrors;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormDirty;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormSubmittable;
    /**
     * @stable [15.02.2019]
     * @returns {boolean}
     */
    private isFormResettable;
    /**
     * @stable [25.02.2019]
     * @returns {boolean}
     */
    private isFormOfNewEntity;
    /**
     * @stable [25.02.2019]
     * @returns {boolean}
     */
    private isFormBusy;
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldReadOnly;
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldDisabled;
    /**
     * @stable [16.11.2018]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldChangeable;
    private getFieldValue;
    private getFieldOriginalValue;
    private getFieldDisplayValue;
    /**
     * @stable [11.09.2019]
     * @param {IField} field
     * @returns {IFieldProps}
     */
    private getPredefinedFieldProps;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly entity;
    /**
     * @stable [10.06.2018]
     * @returns {IEntity}
     */
    private readonly originalEntity;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly changes;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly form;
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    private readonly formActionsWrapperElement;
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    private readonly formActionsElement;
}
