"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../util");
var vue_index_1 = require("../connector/vue-index");
var vue_index_2 = require("../base/vue-index");
var vue_form_interface_1 = require("./vue-form.interface");
var VueForm = /** @class */ (function (_super) {
    __extends(VueForm, _super);
    function VueForm() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [26.11.2018]
     * @returns {boolean}
     */
    VueForm.prototype.hasFooterSlot = function () {
        return this.hasSlot(vue_form_interface_1.VUE_FORM_FOOTER_SLOT);
    };
    /**
     * @stable [26.11.2018]
     * @returns {boolean}
     */
    VueForm.prototype.hasHeaderSlot = function () {
        return this.hasSlot(vue_form_interface_1.VUE_FORM_HEADER_SLOT);
    };
    /**
     * @stable [27.05.2019]
     * @returns {string}
     */
    VueForm.prototype.getClassName = function () {
        return util_1.toClassName('vue-form', util_1.calc(this.className));
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueForm.prototype, "responsive", void 0);
    VueForm = __decorate([
        vue_index_1.ComponentName('vue-form'),
        vue_property_decorator_1.Component({
            template: "\n    <vue-flex-layout :full=\"full\"\n                     :className=\"getClassName()\">\n        <vue-flex-layout v-if=\"title || hasHeaderSlot()\"\n                         :full=\"false\"\n                         :row=\"true\"\n                         class=\"vue-form-header\">\n            <vue-flex-layout v-if=\"title\"\n                             :full=\"false\"\n                             class=\"vue-form-title\">\n                {{title}}\n            </vue-flex-layout>\n            <slot name=\"" + vue_form_interface_1.VUE_FORM_HEADER_SLOT + "\"/>\n        </vue-flex-layout>\n        <vue-flex-layout :full=\"full\"\n                         :responsive=\"responsive\"\n                         :wrap=\"responsive\"\n                         :row=\"true\"\n                         class=\"vue-form-body\">\n            <slot/>\n        </vue-flex-layout>\n        <vue-flex-layout v-if=\"hasFooterSlot()\"\n                         :full=\"false\"\n                         :row=\"true\"\n                         class=\"vue-form-footer\">\n            <slot name=\"" + vue_form_interface_1.VUE_FORM_FOOTER_SLOT + "\"/>\n        </vue-flex-layout>\n    </vue-flex-layout>\n  ",
        })
    ], VueForm);
    return VueForm;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-form.component.js.map