"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../../../util");
var base_grid_column_component_1 = require("../base-column/base-grid-column.component");
var GridColumn = /** @class */ (function (_super) {
    __extends(GridColumn, _super);
    /**
     * @stable [10.09.2018]
     * @param {IGridColumnProps} props
     */
    function GridColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.onColumnClick = _this.onColumnClick.bind(_this);
        return _this;
    }
    /**
     * @stable [10.09.2018]
     * @returns {JSX.Element}
     */
    GridColumn.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return util_1.ifNotFalseThanValue(props.columnRendered, function () { return (React.createElement("td", { style: __assign({}, _this.getStyle({ width: props.columnWidth }), util_1.calc(props.columnStyles, props)), colSpan: util_1.nvl(props.columnColSpan, props.colSpan), className: _this.getClassName(util_1.calc(props.columnClassName, props)), title: util_1.orUndef(!R.isNil(props.columnTitle) || util_1.isPrimitive(props.children), function () { return R.isNil(props.columnTitle) ? props.children : props.columnTitle; }), onClick: props.onColumnClick && _this.onColumnClick }, _this.getColumnContentElement())); });
    };
    /**
     * @stable [10.09.2018]
     * @param {IBaseEvent} event
     */
    GridColumn.prototype.onColumnClick = function (event) {
        var props = this.props;
        props.onColumnClick({ event: event, props: props });
    };
    return GridColumn;
}(base_grid_column_component_1.BaseGridColumn));
exports.GridColumn = GridColumn;
//# sourceMappingURL=grid-column.component.js.map