"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var base_1 = require("../../base");
var button_1 = require("../../button");
var configurations_definitions_interface_1 = require("../../../configurations-definitions.interface");
var util_1 = require("../../../util");
var keyboard_interface_1 = require("../keyboard.interface");
var KeyboardKey = /** @class */ (function (_super) {
    __extends(KeyboardKey, _super);
    /**
     * @stable [26.01.2019]
     * @param {IKeyboardKeyProps} props
     */
    function KeyboardKey(props) {
        var _this = _super.call(this, props) || this;
        _this.buttonRef = React.createRef();
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    /**
     * @stable [27.01.2019]
     * @returns {JSX.Element}
     */
    KeyboardKey.prototype.render = function () {
        var props = this.props;
        var keyAsString = props.value;
        var keyAsObject = props.value;
        var value = util_1.isString(keyAsString)
            ? (props.useUppercase
                ? keyAsString.toUpperCase()
                : keyAsString)
            : (keyAsObject.type === configurations_definitions_interface_1.KeyboardKeyEnum.UPPERCASE
                ? (props.useUppercase ? keyboard_interface_1.KEYBOARD_SPECIAL_KEYS.LOWERCASE : keyAsObject.value)
                : keyAsObject.value);
        return (React.createElement(button_1.Button, { ref: this.buttonRef, disabled: props.disabled, rippled: props.rippled, className: util_1.joinClassName('rac-keyboard-key', "rac-keyboard-key-" + value, keyAsObject && util_1.calc(keyAsObject.className), util_1.calc(props.className, value)), style: keyAsObject && keyAsObject.width ? { width: keyAsObject.width + "px" } : {}, onClick: this.onClick }, util_1.isFn(props.renderer) ? props.renderer(value) : value));
    };
    /**
     * @stable [08.05.2018]
     */
    KeyboardKey.prototype.onClick = function () {
        this.buttonRef.current.blur();
        this.props.onSelect(this.props.value);
    };
    return KeyboardKey;
}(base_1.BaseComponent));
exports.KeyboardKey = KeyboardKey;
//# sourceMappingURL=keyboard-key.component.js.map