import * as React from 'react';
import { IKeyValue } from '../../../definitions.interface';
import { ILayoutBuilderConfiguration, ReactLayoutBuilderChildrenT } from '../../../react-configurations-definitions.interface';
import { ReactBaseLayoutViewBuilder } from './react-base-layout-view.builder';
export declare class RnLayoutViewBuilder extends ReactBaseLayoutViewBuilder {
    /**
     * @stable - 16.04.2018
     * @param {IKeyValue} props
     * @param {React.ReactNode[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    buildRowView(props: IKeyValue, children: ReactLayoutBuilderChildrenT[], layoutConfig: ILayoutBuilderConfiguration): React.ReactNode;
    /**
     * @stable - 19.04.2018
     * @param {IKeyValue} props
     * @param {React.ReactNode[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    buildColumnView(props: IKeyValue, children: ReactLayoutBuilderChildrenT[], layoutConfig: ILayoutBuilderConfiguration): React.ReactNode;
    /**
     * @stable - 16.04.2018
     * @param {IKeyValue} props
     * @returns {React.ReactNode}
     */
    buildSeparatorView(props: IKeyValue): React.ReactNode;
    /**
     * @stable - 19.04.2018
     * @param {ReactLayoutBuilderChildrenT} item
     * @returns {boolean}
     */
    isClonedItem(item: ReactLayoutBuilderChildrenT): boolean;
    /**
     * @stable [22.10.2018]
     * @param {JSX.Element} item
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @param {IKeyValue} props
     * @returns {IKeyValue}
     */
    getClonedItemProps(item: JSX.Element, layoutConfig: ILayoutBuilderConfiguration, props: IKeyValue): IKeyValue;
    /**
     * @stable - 16.04.2018
     * @param {LayoutBuilderFactorsEnum} factor
     * @returns {number}
     */
    private toFactorStyle;
}
