"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var native_base_1 = require("native-base");
var util_1 = require("../../../util");
var configurations_definitions_interface_1 = require("../../../configurations-definitions.interface");
var react_base_layout_view_builder_1 = require("./react-base-layout-view.builder");
var RnLayoutViewBuilder = /** @class */ (function (_super) {
    __extends(RnLayoutViewBuilder, _super);
    function RnLayoutViewBuilder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable - 16.04.2018
     * @param {IKeyValue} props
     * @param {React.ReactNode[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    RnLayoutViewBuilder.prototype.buildRowView = function (props, children, layoutConfig) {
        return (React.createElement(native_base_1.View, __assign({}, props, { style: __assign({ flexDirection: 'row', flex: this.toFactorStyle(layoutConfig.factor) }, layoutConfig.style) }), children));
    };
    /**
     * @stable - 19.04.2018
     * @param {IKeyValue} props
     * @param {React.ReactNode[]} children
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @returns {React.ReactNode}
     */
    RnLayoutViewBuilder.prototype.buildColumnView = function (props, children, layoutConfig) {
        return (React.createElement(native_base_1.View, __assign({}, props, { style: __assign({ flexDirection: 'column', flex: this.toFactorStyle(layoutConfig.factor) }, layoutConfig.style) }), children));
    };
    /**
     * @stable - 16.04.2018
     * @param {IKeyValue} props
     * @returns {React.ReactNode}
     */
    RnLayoutViewBuilder.prototype.buildSeparatorView = function (props) {
        return (React.createElement(native_base_1.View, __assign({}, props, { style: { flex: .1 } })));
    };
    /**
     * @stable - 19.04.2018
     * @param {ReactLayoutBuilderChildrenT} item
     * @returns {boolean}
     */
    RnLayoutViewBuilder.prototype.isClonedItem = function (item) {
        var itemEl = item;
        return (itemEl.type && util_1.isDef(itemEl.type.displayName)) || _super.prototype.isClonedItem.call(this, item);
    };
    /**
     * @stable [22.10.2018]
     * @param {JSX.Element} item
     * @param {ILayoutBuilderConfiguration} layoutConfig
     * @param {IKeyValue} props
     * @returns {IKeyValue}
     */
    RnLayoutViewBuilder.prototype.getClonedItemProps = function (item, layoutConfig, props) {
        var itemEl = item;
        return __assign({}, props, { style: layoutConfig.full === false
                ? itemEl.props.style
                : __assign({ flex: 1 }, itemEl.props.style) });
    };
    /**
     * @stable - 16.04.2018
     * @param {LayoutBuilderFactorsEnum} factor
     * @returns {number}
     */
    RnLayoutViewBuilder.prototype.toFactorStyle = function (factor) {
        switch (factor) {
            case configurations_definitions_interface_1.LayoutBuilderFactorsEnum.FACTOR_2:
                return 2;
            case configurations_definitions_interface_1.LayoutBuilderFactorsEnum.FACTOR_4:
                return 4;
            case configurations_definitions_interface_1.LayoutBuilderFactorsEnum.FACTOR_8:
                return 8;
            default:
                return 1;
        }
    };
    return RnLayoutViewBuilder;
}(react_base_layout_view_builder_1.ReactBaseLayoutViewBuilder));
exports.RnLayoutViewBuilder = RnLayoutViewBuilder;
//# sourceMappingURL=rn-layout-view.builder.js.map