"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../util");
var item_1 = require("./item");
var simple_1 = require("../list/simple");
var base_list_component_1 = require("./base-list.component");
var List = /** @class */ (function (_super) {
    __extends(List, _super);
    function List() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * [30.10.2018]
     * @returns {JSX.Element}
     */
    List.prototype.getView = function () {
        var _this = this;
        var props = this.props;
        return (React.createElement(simple_1.SimpleList, __assign({ ref: 'container' }, props),
            this.dataSource.map(function (item, index) { return _this.getItem(item, index); }),
            this.addActionElement));
    };
    /**
     * @stable [13.09.2018]
     * @param {IEntity} entity
     * @param {number} index
     * @returns {JSX.Element}
     */
    List.prototype.getItem = function (entity, index) {
        var props = this.props;
        var rowKey = this.toRowKey(entity);
        return (React.createElement(item_1.ListItem, __assign({ ref: rowKey, key: rowKey, index: index, rawData: entity, selected: this.isEntitySelected(entity), onClick: this.onSelect }, props.itemConfiguration, { className: util_1.toClassName(props.itemConfiguration.className, props.applyOdd !== false && (util_1.isOddNumber(index) ? 'rac-list-item-odd' : '')) })));
    };
    return List;
}(base_list_component_1.BaseList));
exports.List = List;
//# sourceMappingURL=list.component.js.map