"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var list_interface_1 = require("./list.interface");
var list_reducer_1 = require("./list.reducer");
var list_action_builder_1 = require("./list-action.builder");
var TEST_SECTION = 'test';
describe('list.reducer', function () {
    describe(list_interface_1.LIST_REMOVE_ACTION_TYPE, function () {
        it('test1', function () {
            var entity1 = { id: 1, name: '1' };
            var entity2 = { id: 2, name: '2' };
            var entity3 = { id: 3, name: '3' };
            var reducedList = list_reducer_1.listReducer(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity2,
                    entity3
                ],
                selected: entity2,
                totalCount: 3,
            }), {
                type: list_action_builder_1.ListActionBuilder.buildRemoveActionType(TEST_SECTION),
                data: {
                    section: TEST_SECTION,
                    removed: entity2,
                },
            });
            expect(reducedList).toEqual(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity3
                ],
                selected: null,
                totalCount: 2,
            }));
        });
        it('test2', function () {
            var entity1 = { id: 1, name: '1' };
            var entity2 = { id: 2, name: '2' };
            var entity3 = { id: 3, name: '3' };
            var reducedList = list_reducer_1.listReducer(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity2,
                    entity3
                ],
                selected: entity2,
                totalCount: 3,
            }), {
                type: list_action_builder_1.ListActionBuilder.buildRemoveActionType(TEST_SECTION),
                data: {
                    section: TEST_SECTION,
                    removed: { id: 2, name: '2' },
                },
            });
            expect(reducedList).toEqual(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity3
                ],
                selected: null,
                totalCount: 2,
            }));
        });
        it('test3', function () {
            var entity1 = { id: 1, name: '1' };
            var entity2 = { id: 2, name: '2' };
            var entity3 = { id: 3, name: '3' };
            var reducedList = list_reducer_1.listReducer(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity2,
                    entity3
                ],
                selected: entity3,
                totalCount: 3,
            }), {
                type: list_action_builder_1.ListActionBuilder.buildRemoveActionType(TEST_SECTION),
                data: {
                    section: TEST_SECTION,
                    removed: entity2,
                },
            });
            expect(reducedList).toEqual(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity3
                ],
                selected: entity3,
                totalCount: 2,
            }));
        });
        it('test4', function () {
            var entity1 = { id: 1, name: '1' };
            var entity2 = { id: 2, name: '2' };
            var entity3 = { id: 3, name: '3' };
            var reducedList = list_reducer_1.listReducer(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity2,
                    entity3
                ],
                totalCount: 3,
            }), {
                type: list_action_builder_1.ListActionBuilder.buildRemoveActionType(TEST_SECTION),
                data: {
                    section: TEST_SECTION,
                    removed: entity2,
                },
            });
            expect(reducedList).toEqual(Object.assign({}, list_interface_1.INITIAL_APPLICATION_LIST_STATE, {
                data: [
                    entity1,
                    entity3
                ],
                totalCount: 2,
            }));
        });
    });
});
//# sourceMappingURL=list.reducer.spec.js.map