import { IContainer } from '../../../entities-definitions.interface';
import { IContainerProps } from '../../../props-definitions.interface';
import { IDispatcher } from '../../../definition';
import { IKeyValue } from '../../../definitions.interface';
export declare class StoreDispatcherProxy<TStore, TProps extends IContainerProps> implements IDispatcher {
    private readonly container;
    /**
     * @stable [11.09.2019]
     * @param {IContainer<TProps>} container
     */
    constructor(container: IContainer<TProps>);
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TChanges} data
     */
    dispatch<TChanges = IKeyValue>(type: string, data?: TChanges): void;
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TData} data
     */
    dispatchCustomType<TData = IKeyValue>(type: string, data?: TData): void;
    /**
     * @stable [11.09.2019]
     * @param {string} otherSection
     */
    dispatchFormReset(otherSection?: string): void;
    /**
     * @stable [11.09.2019]
     * @param {AnyAction} action
     */
    private dispatchAnyAction;
    /**
     * @reactNativeCompatible
     * @stable [11.09.2019]
     * @returns {Store<TStore>}
     */
    private readonly appStore;
    /**
     * @stable [11.09.2019]
     * @returns {string}
     */
    private readonly sectionName;
    /**
     * @stable [11.09.2019]
     * @returns {TProps}
     */
    private readonly props;
}
