"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../../util");
var di_1 = require("../../../di");
var action_builder_1 = require("../../action.builder");
var StoreDispatcherProxy = /** @class */ (function () {
    /**
     * @stable [11.09.2019]
     * @param {IContainer<TProps>} container
     */
    function StoreDispatcherProxy(container) {
        this.container = container;
    }
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TChanges} data
     */
    StoreDispatcherProxy.prototype.dispatch = function (type, data) {
        this.dispatchCustomType(this.sectionName + "." + type, util_1.applySection(this.sectionName, data));
    };
    /**
     * @stable [11.09.2019]
     * @param {string} type
     * @param {TData} data
     */
    StoreDispatcherProxy.prototype.dispatchCustomType = function (type, data) {
        this.dispatchAnyAction({ type: type, data: data });
    };
    /**
     * @stable [11.09.2019]
     * @param {string} otherSection
     */
    StoreDispatcherProxy.prototype.dispatchFormReset = function (otherSection) {
        this.dispatchAnyAction(action_builder_1.FormActionBuilder.buildResetPlainAction(otherSection || this.sectionName));
    };
    /**
     * @stable [11.09.2019]
     * @param {AnyAction} action
     */
    StoreDispatcherProxy.prototype.dispatchAnyAction = function (action) {
        this.appStore.dispatch(action);
    };
    Object.defineProperty(StoreDispatcherProxy.prototype, "appStore", {
        /**
         * @reactNativeCompatible
         * @stable [11.09.2019]
         * @returns {Store<TStore>}
         */
        get: function () {
            return di_1.staticInjector(di_1.DI_TYPES.Store);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreDispatcherProxy.prototype, "sectionName", {
        /**
         * @stable [11.09.2019]
         * @returns {string}
         */
        get: function () {
            return this.props.sectionName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StoreDispatcherProxy.prototype, "props", {
        /**
         * @stable [11.09.2019]
         * @returns {TProps}
         */
        get: function () {
            return this.container.props;
        },
        enumerable: true,
        configurable: true
    });
    StoreDispatcherProxy = __decorate([
        util_1.namedConstructor('$$storeDispatcherProxy'),
        __metadata("design:paramtypes", [Object])
    ], StoreDispatcherProxy);
    return StoreDispatcherProxy;
}());
exports.StoreDispatcherProxy = StoreDispatcherProxy;
//# sourceMappingURL=store-dispatcher.proxy.js.map