"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var R = require("ramda");
var root_container_1 = require("./root.container");
var PrivateRootContainer = /** @class */ (function (_super) {
    __extends(PrivateRootContainer, _super);
    function PrivateRootContainer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PrivateRootContainer.prototype.render = function () {
        var _this = this;
        var Component = this.props.container;
        var accessConfiguration = this.props.accessConfiguration;
        var render = function (_) {
            if (_this.auth.isAuthorized()) {
                return accessConfiguration && !_this.permissionService.isAccessible(accessConfiguration)
                    ? React.createElement(react_router_dom_1.Redirect, { to: 'access/denied' })
                    : React.createElement(Component, { routeParams: _this.routeParams, queryParams: _this.queryParams });
            }
            else {
                var queryParams = _this.queryParams.toString();
                return React.createElement(react_router_dom_1.Redirect, { to: R.isEmpty(queryParams) ? _this.routes.signIn : _this.routes.signIn + "/?" + queryParams });
            }
        };
        return React.createElement(react_router_dom_1.Route, { render: render });
    };
    return PrivateRootContainer;
}(root_container_1.RootContainer));
exports.PrivateRootContainer = PrivateRootContainer;
//# sourceMappingURL=private-root.container.js.map