"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
/**
 * @stable [30.08.2018]
 * @param {IActiveValueWrapper} activeValueWrapper
 * @param {ITabConfiguration} tab
 * @returns {boolean}
 */
exports.isTabActive = function (activeValueWrapper, tab) {
    return R.isNil(activeValueWrapper.activeValue) ? !!tab.active : activeValueWrapper.activeValue === tab.value;
};
/**
 * @stable [30.08.2018]
 * @param {IActiveValueWrapper} props
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {number}
 */
exports.getTabActiveValue = function (props, tabPanelConfiguration) {
    var currentActiveValue = props.activeValue;
    if (!R.isNil(currentActiveValue)) {
        return currentActiveValue;
    }
    var tabs = tabPanelConfiguration.items;
    var activeTab = tabs.find(function (tab) { return tab.active; });
    if (R.isNil(activeTab)) {
        return tabs[0].value;
    }
    return activeTab.value;
};
//# sourceMappingURL=tabpanel.support.js.map