import * as React from 'react';
import * as CSS from 'csstype';
import { AnyT, EntityIdT, IActionButtonsWrapper, IActionedWrapper, IActionIconsWrapper, IActionIconWrapper, IActionsDisabledWrapper, IActionsPosition, IActionsWrapper, IActiveValueWrapper, IActiveWrapper, IAfterEnterWrapper, IAliasWrapper, IAlignWrapper, IAlwaysDirtyWrapper, IApplyGroupWrapper, IApplyOddWrapper, IAutoCompleteWrapper, IAutoFocusWrapper, IAvatarWrapper, IBackwardRenderedWrapper, IBasenameWrapper, IBeforeEnterWrapper, IBindDictionaryWrapper, IBooleanEmptyDataWrapper, IBooleanModalWrapper, ICallbackWrapper, ICameraHeightWrapper, ICameraWidthWrapper, ICanReturnClearDirtyChangesValueWrapper, ICaretBlinkingFrequencyTimeoutWrapper, ICenterAlignmentWrapper, ICenteredMenuWrapper, ICenteredWrapper, IChangeableWrapper, IChangeFormWrapper, IChildrenWrapper, IClassNameWrapper, IClearActionWrapper, IColSpanWrapper, IColumnClassNameWrapper, IColumnColSpanWrapper, IColumnNameWrapper, IColumnRenderedWrapper, IColumnStylesWrapper, IColumnTitleWrapper, IColumnWidthWrapper, ICompactWrapper, IComputedMatchWrapper, IContentStyleWrapper, IContentWrapper, IDeactivatedWrapper, IDefaultValue, IDelayTimeoutWrapper, IDisabledWrapper, IDisplayMessageWrapper, IDisplayNameWrapper, IDrawerContentStyleWrapper, IDrawerContentWrapper, IEditableWrapper, IEmptyDataMessageWrapper, IEmptyMessageWrapper, IEntity, IEntityToClassNameWrapper, IEntityWrapper, IErrorMessageRenderedWrapper, IErrorMessageWrapper, IExactWrapper, IExpandActionRenderedWrapper, IExpandedGroupsWrapper, IFactorWrapper, IFieldRenderedWrapper, IFieldWrapper, IFilterFnWrapper, IFilterPlaceholderWrapper, IFilterRendererWrapper, IFilterWrapper, IFocusEvent, IForwardRenderedWrapper, IFullWrapper, IGroupByWrapper, IHasContentWrapperWrapper, IHeaderActionIconStyleWrapper, IHeaderActionStyleWrapper, IHeaderBackActionEnabledWrapper, IHeaderClassNameWrapper, IHeaderColSpanWrapper, IHeaderContentWrapper, IHeaderMenuActionEnabledWrapper, IHeaderRenderedWrapper, IHeaderRendererWrapper, IHeaderStyleWrapper, IHeaderTitleStyleWrapper, IHeaderWidthWrapper, IHideNavBarWrapper, IHomeWrapper, IHoveredWrapper, IIconWrapper, IIndexWrapper, IInitialWrapper, IItemsWrapper, IKeyboardConfigurationWrapper, IKeyboardEvent, IKeyValue, IKeyWrapper, ILayoutWrapper, ILocalFilterFnWrapper, ILogoutWrapper, IMappersWrapper, IMaskGuideWrapper, IMaskPlaceholderCharWrapper, IMaxCountWrapper, IMessageWrapper, IMoreOptionsWrapper, IMultiWrapper, INameWrapper, INavigationActionTypeWrapper, INotUseFieldWrapper, IOnBlurWrapper, IOnChangeFilterWrapper, IOnChangeGroupingWrapper, IOnChangeHeaderWrapper, IOnChangeSortingWrapper, IOnChangeWrapper, IOnClearWrapper, IOnClickWrapper, IOnCloseWrapper, IOnCreateWrapper, IOnDeactivateWrapper, IOnDelayWrapper, IOnEmptyDictionaryWrapper, IOnEnterWrapper, IOnFilterChangeWrapper, IOnFocusWrapper, IOnLoadDictionaryWrapper, IOnMoreOptionsSelectWrapper, IOnScrollWrapper, IOnSelectWrapper, IParamsWrapper, IPathWrapper, IPluginsWrapper, IPrefixLabelWrapper, IPreventFocusWrapper, IProfileWrapper, IQueryWrapper, IReadOnlyWrapper, IRegisterWrapper, IRenderedWrapper, IRendererWrapper, IRenderToBodyWrapper, IRenderToXWrapper, IRenderToYWrapper, IRequiredWrapper, IResetActionRenderedWrapper, IResetIconWrapper, IRestoreAuthWrapper, IRippableWrapper, ISelectableWrapper, ISelectedWrapper, ISeparatorsWrapper, IShadowStyleWrapper, ISignInWrapper, ISignUpWrapper, ISimpleWrapper, ISorterFnWrapper, IStepWrapper, IStickyHeadWrapper, IStringArrayExcludeTargetsClassesWrapper, IStyleWrapper, ISubBorderWrapper, ITightGridWrapper, ITitleRendererWrapper, ITitleWrapper, ITotalEntityWrapper, ITplFnWrapper, ITplWrapper, ITypeWrapper, IUnregisterWrapper, IUrlWrapper, IUseAddActionWrapper, IUseDrawerWrapper, IUseFilterWrapper, IUseGroupingWrapper, IUseHeaderWrapper, IUseIndicatorWrapper, IUseKeyboardWrapper, IUseSortingWrapper, IUseSyntheticCursorWrapper, IValidateWrapper, IValidationGroupWrapper, IValueWrapper, IWarningWrapper, IWidthWrapper, IWrapperClassNameWrapper, StringNumberT, IAccessConfigurationWrapper } from './definitions.interface';
import { IFieldChangeEntity, IMenuItemEntity, ISortDirectionEntity, IUniversalStoreEntity, IUniversalComponent, IUniversalComponentPluginClassEntity, IUniversalContainerClassEntity, IXYEntity } from './entities-definitions.interface';
import { IGridColumnProps } from './props-definitions.interface';
import { IReactOnClickWrapper, IOnColumnClickWrapper, IOnNavigationActionClickWrapper } from './react-definitions.interface';
import { IApiEntity, IBaseEvent, IButtonProps, IGenericButtonEntity, IGenericFieldEntity, IGenericFormEntity, INamedConstructor, IUniversalContainerEntity, INavigationItemEntity, IWebComponentEntity } from './definition';
/**
 * @stable [16.06.2018]
 */
export interface IButtonConfigurationWrapper<TButtonConfiguration = IButtonProps> {
    buttonConfiguration?: TButtonConfiguration;
}
/**
 * @stable [31.05.2018]
 */
export interface IHeaderConfigurationWrapper<THeaderConfiguration = ISubHeaderConfiguration> {
    headerConfiguration?: THeaderConfiguration;
}
/**
 * @stable [14.05.2018]
 */
export interface IItemConfigurationWrapper<TItemConfiguration> {
    itemConfiguration?: TItemConfiguration;
}
/**
 * @stable [18.05.2018]
 */
export interface IFilterConfigurationWrapper<TFilterConfiguration = IFilterConfiguration> {
    filterConfiguration?: IFilterConfiguration;
}
/**
 * @stable [18.05.2018]
 */
export interface IFieldConfigurationWrapper<TFieldConfiguration = IFieldConfiguration> {
    fieldConfiguration?: TFieldConfiguration;
}
/**
 * @stable [14.05.2018]
 */
export interface IMenuConfigurationWrapper<TMenuConfiguration = IMenuConfiguration> {
    menuConfiguration?: TMenuConfiguration;
}
/**
 * @stable [14.05.2018]
 */
export interface IColumnsConfigurationWrapper<TColumnsConfiguration = IGridColumnConfiguration[]> {
    columnsConfiguration?: TColumnsConfiguration;
}
/**
 * @stable [14.05.2018]
 */
export interface IListConfigurationWrapper<TListConfiguration = IListConfiguration> {
    listConfiguration?: TListConfiguration;
}
/**
 * @stable [02.06.2018]
 */
export interface IGridConfigurationWrapper<TGridConfiguration = IGridConfiguration> {
    gridConfiguration?: TGridConfiguration;
}
/**
 * @stable [31.08.2018]
 */
export interface ITabPanelConfigurationWrapper<TabPanelConfiguration = ITabPanelConfiguration> {
    tabPanelConfiguration?: TabPanelConfiguration;
}
export interface IRouteConfigurationWrapper<TRouteConfiguration> {
    routeConfiguration?: TRouteConfiguration;
}
/**
 * @stable [18.06.2018]
 */
export interface IUniversalKeyboardHandlersConfiguration<TKeyboardEvent> {
    onKeyTab?(event: TKeyboardEvent): void;
    onKeyEnter?(event: TKeyboardEvent): void;
    onKeyUp?(event: TKeyboardEvent): void;
    onKeyDown?(event: TKeyboardEvent): void;
    onKeyEscape?(event: TKeyboardEvent): void;
    onKeyArrowDown?(event: TKeyboardEvent): void;
    onKeyArrowUp?(event: TKeyboardEvent): void;
    onKeyBackspace?(event: TKeyboardEvent): void;
}
/**
 * @stable [16.05.2018]
 */
export interface INavigationHandlersConfiguration {
    onPrevious?(): void;
    onNext?(): void;
    onFirst?(): void;
    onLast?(): void;
}
/**
 * @stable [18.05.2018]
 */
export interface IReactComponentConfiguration extends React.ClassAttributes<AnyT>, ITitleWrapper, IOnScrollWrapper<IXYEntity>, IPluginsWrapper<IUniversalComponentPluginClassEntity | IUniversalComponentPluginClassEntity[]>, IRegisterWrapper<(component: IUniversalComponent) => void>, IUnregisterWrapper<(component: IUniversalComponent) => void> {
}
/**
 * @stable [24.04.2018]
 */
export interface IUniversalListItemConfiguration extends IReactComponentConfiguration, IRendererWrapper, IIndexWrapper, ITplFnWrapper, IWarningWrapper {
}
export interface IRnListItemConfiguration extends IUniversalListItemConfiguration, IAvatarWrapper<string | ((data: IKeyValue) => string)>, ISeparatorsWrapper<IKeyValue> {
}
export interface IListItemConfiguration extends IUniversalListItemConfiguration, IWebComponentEntity, IEntityToClassNameWrapper, IIconWrapper<UIIconConfigurationT> {
}
/**
 * @stable [04.05.2018]
 */
export interface ICardListItemConfiguration extends IUniversalListItemConfiguration, IWebComponentEntity<string | ((...args: any[]) => string)>, IActionButtonsWrapper<(entity: IEntity) => React.ReactNode>, IActionIconsWrapper<(entity: IEntity) => React.ReactNode> {
    rippable?: boolean;
    rippled?: boolean;
}
/**
 * @stable [05.10.2018]
 */
export declare type GroupValueRendererT = (groupedRowValue: EntityIdT, groupedRows: IEntity[]) => React.ReactNode;
export interface IUniversalListConfiguration<TItemConfiguration extends IUniversalListItemConfiguration = IUniversalListItemConfiguration> extends IReactComponentConfiguration, IFilterAndSorterConfiguration, IEmptyMessageWrapper, IEmptyDataMessageWrapper, IUseAddActionWrapper, IOnCreateWrapper, IOnSelectWrapper, IOnChangeWrapper<IFieldChangeEntity>, IOnChangeHeaderWrapper<IFieldChangeEntity>, IOnChangeFilterWrapper<IFieldChangeEntity>, IItemConfigurationWrapper<TItemConfiguration>, IDeactivatedWrapper, IApplyOddWrapper, IApplyGroupWrapper, IHoveredWrapper, IFullWrapper, ISelectableWrapper, IGroupByWrapper<{
    columnName: string;
    groupValue: GroupValueRendererT | GroupValueRendererT[];
}> {
    useLocalFiltering?: boolean;
    useLocalSorting?: boolean;
}
export interface IRnListConfiguration extends IUniversalListConfiguration<IRnListItemConfiguration> {
}
export interface ICardListConfiguration extends IUniversalListConfiguration<ICardListItemConfiguration>, IWebComponentEntity {
}
export interface IListConfiguration extends IUniversalListConfiguration<IListItemConfiguration>, IWebComponentEntity {
}
/**
 * @stable [04.08.2018]
 */
export interface IUniversalFormConfiguration extends IGenericFormEntity, IReactComponentConfiguration, IResetActionRenderedWrapper, IEditableWrapper, IDisabledWrapper, IAlwaysDirtyWrapper, IActionIconWrapper, IResetIconWrapper, IChangeableWrapper, IFullWrapper, IOnEmptyDictionaryWrapper<IApiEntity> {
}
export interface IFormExtraActionProps extends IGenericButtonEntity, IOnClickWrapper<(apiEntity: IApiEntity) => void> {
}
export interface IFormConfigurationEntity extends IUniversalFormConfiguration, IWebComponentEntity, IButtonConfigurationWrapper, IReadOnlyWrapper, ICompactWrapper {
    actionsProvider?: (defaultActions: IFormExtraActionProps[]) => IFormExtraActionProps[];
    progress?: boolean;
    alwaysResettable?: boolean;
    validateOnMount?: boolean;
    submitActionConfiguration?: IButtonProps;
    resetActionConfiguration?: IButtonProps;
}
/**
 * @stable [10.09.2018]
 */
export interface IBaseGridColumnConfiguration extends IComponentConfiguration, IAlignWrapper, IWidthWrapper, IColSpanWrapper, IIndexWrapper, IColumnStylesWrapper<((props: IGridColumnProps) => CSS.Properties<string | number>)> {
}
/**
 * @deprecated Use IGridColumnProps
 */
export interface IGridColumnConfiguration extends IBaseGridColumnConfiguration, IOnColumnClickWrapper<{
    event: IBaseEvent;
    props: IGridColumnProps;
}>, IColumnColSpanWrapper, IColumnTitleWrapper, IColumnWidthWrapper, IColumnClassNameWrapper<string | ((props: IGridColumnProps) => string)>, IColumnRenderedWrapper, ILocalFilterFnWrapper<IGridFilterConfiguration>, IReactOnClickWrapper<ISortDirectionEntity>, IUseGroupingWrapper, IUseSortingWrapper, ITplWrapper<((entity: IEntity, column?: IGridColumnProps, rowNum?: number) => StringNumberT)>, INameWrapper, IRenderedWrapper, IRendererWrapper<IEntity, IGridColumnConfiguration>, IActionedWrapper, IHeaderRendererWrapper<IGridColumnConfiguration>, IFilterRendererWrapper<IGridColumnConfiguration> {
    sorter?(entity1: IEntity, entity2: IEntity): number;
}
/**
 * @stable [03.07.2018]
 */
export interface IGridFilterConfiguration<TEntity extends IEntity = IEntity> extends IQueryWrapper, IColumnNameWrapper, IEntityWrapper<TEntity> {
}
export interface IGridConfiguration extends IUniversalListConfiguration, IWebComponentEntity, IWrapperClassNameWrapper, IOnChangeGroupingWrapper<IFieldChangeEntity>, IOnChangeSortingWrapper<ISortDirectionEntity>, IColumnsConfigurationWrapper, IExpandActionRenderedWrapper, IExpandedGroupsWrapper, ITightGridWrapper, IStickyHeadWrapper, ITotalEntityWrapper<IEntity> {
    topTotal?: boolean;
    groupedDataSorter?: (groupedValue1: any, groupedValue2: any, entity1: IEntity, entity2: IEntity) => number;
}
export interface IGridHeaderColumnConfiguration extends IGridColumnConfiguration, IHeaderColSpanWrapper, IHeaderWidthWrapper, IHeaderClassNameWrapper, IHeaderRenderedWrapper {
}
/**
 * @stable [10.09.2018]
 */
export declare type GridColumnConfigurationT = IGridColumnConfiguration | IGridHeaderColumnConfiguration;
/**
 * @stable [31.08.2018]
 */
export interface ITabConfiguration extends IValueWrapper, IClassNameWrapper, IActiveWrapper, INameWrapper, ISelectedWrapper, IUrlWrapper, IIconWrapper, IAliasWrapper, IActiveValueWrapper {
}
/**
 * @stable [30.08.2018]
 */
export interface ITabPanelConfiguration extends IComponentConfiguration, IUseIndicatorWrapper, IRippableWrapper, ICenteredWrapper, IBackwardRenderedWrapper, IForwardRenderedWrapper, IOnCloseWrapper<ITabConfiguration>, IReactOnClickWrapper<ITabConfiguration>, IOnDeactivateWrapper<(value: AnyT) => void>, IItemsWrapper<ITabConfiguration[]> {
}
/**
 * @stable [02.08.2018]
 */
export interface IWebCameraConfiguration extends IComponentConfiguration, ICameraWidthWrapper, ICameraHeightWrapper, IOnSelectWrapper<Blob> {
}
export interface IRnApplicationConfiguration extends IReactComponentConfiguration, IHideNavBarWrapper {
}
export interface IApplicationConfiguration extends IBasenameWrapper, IHideNavBarWrapper {
}
/**
 * @stable [18.04.2018]
 */
export declare enum FieldActionPositionEnum {
    LEFT = 0,
    RIGHT = 1
}
/**
 * @stable [08.05.2018]
 */
export declare enum KeyboardKeyEnum {
    UPPERCASE = 0,
    CHANGE_LAYOUT = 1,
    LOWERCASE = 2,
    BACKSPACE = 3,
    CLOSE = 4,
    SPACE = 5,
    ENTER = 6
}
export declare type KeyboardKeyT = string | IKeyboardKey;
export declare type KeyboardLayoutT = KeyboardKeyT[][];
export interface IKeyboardKey extends IValueWrapper<string>, ITypeWrapper<KeyboardKeyEnum>, IClassNameWrapper<string | ((...args: any[]) => string)>, // TODO
IWidthWrapper {
}
export interface IKeyboardKeyConfiguration extends IDisabledWrapper {
    renderer?: any;
    className?: any;
}
/**
 * @stable [08.05.2018]
 */
export interface IKeyboardConfiguration extends IComponentConfiguration, IFieldWrapper<HTMLInputElement | HTMLTextAreaElement>, ILayoutWrapper<KeyboardLayoutT[]>, IOnCloseWrapper, IRenderToBodyWrapper {
    keyboardKeyConfiguration?: IKeyboardKeyConfiguration;
}
/**
 * @stable [31.07.2018]
 */
export interface IUniversalFieldConfiguration<TKeyboardEvent, TFocusEvent, TBasicEvent> extends IGenericFieldEntity, IReactComponentConfiguration, IUniversalKeyboardHandlersConfiguration<TKeyboardEvent>, IDelayedChangesFieldPluginConfiguration, IOnFocusWrapper<TFocusEvent>, IOnBlurWrapper<TFocusEvent>, IReactOnClickWrapper<TBasicEvent>, IOnChangeWrapper, IOnClearWrapper, IChangeFormWrapper<(name: string, value: AnyT, validationGroup?: string) => void>, IAutoFocusWrapper, IErrorMessageRenderedWrapper, IActionsWrapper<IFieldActionConfiguration[]>, IDisplayMessageWrapper, IValidationGroupWrapper, IRenderedWrapper, IPreventFocusWrapper, IRequiredWrapper, ICanReturnClearDirtyChangesValueWrapper, IMessageWrapper, IUseKeyboardWrapper, IKeyboardConfigurationWrapper<IKeyboardConfiguration>, ICaretBlinkingFrequencyTimeoutWrapper, IValidateWrapper<string>, IFieldRenderedWrapper, IFullWrapper, IUseSyntheticCursorWrapper, IChangeableWrapper, IDefaultValue {
    bufferValue?: boolean;
    preventManualChanges?: boolean;
    dispatchValue?(rawValue: AnyT): any;
}
export interface IFieldConfiguration extends IUniversalFieldConfiguration<IKeyboardEvent, IFocusEvent, IBaseEvent>, IWebComponentEntity, IAutoCompleteWrapper, IActionsPosition<FieldActionPositionEnum>, IBindDictionaryConfiguration, IMaskGuideWrapper, IMaskPlaceholderCharWrapper, IPrefixLabelWrapper, IDisplayNameWrapper, ITypeWrapper<StringNumberT>, IClearActionWrapper, IStepWrapper {
}
/**
 * @stable [18.06.2018]
 */
export interface IFieldsConfigurations {
    [fieldName: string]: string | IFieldConfiguration | ((field: any) => IFieldConfiguration | string);
}
export interface IRoutesConfiguration extends IRestoreAuthWrapper<string>, IHomeWrapper<string>, IProfileWrapper<string>, ILogoutWrapper<string>, ISignInWrapper<string>, ISignUpWrapper<string> {
}
export interface IRouteComputedMatchConfiguration extends IParamsWrapper, IUrlWrapper, IPathWrapper {
}
export declare enum ContainerVisibilityTypeEnum {
    PUBLIC = 0,
    PRIVATE = 1
}
export interface IRouteConfigEntity extends IPathWrapper, IBooleanModalWrapper, ITitleWrapper, IInitialWrapper<boolean | ((store: IUniversalStoreEntity) => boolean)>, IExactWrapper, IKeyWrapper, IOnEnterWrapper<() => void>, IAfterEnterWrapper<() => void>, IBeforeEnterWrapper<() => void>, IComputedMatchWrapper<IRouteComputedMatchConfiguration>, ITypeWrapper<ContainerVisibilityTypeEnum> {
}
export declare type ConnectorMapperT<TStoreEntity> = (state: TStoreEntity) => IKeyValue;
export interface IBasicConnectorConfigEntity<TStoreEntity> extends ICallbackWrapper<(ctor: IUniversalContainerClassEntity) => void>, IRouteConfigurationWrapper<IRouteConfigEntity>, IMappersWrapper<Array<ConnectorMapperT<TStoreEntity>>> {
    injectedServices?: INamedConstructor[];
}
export interface IConnectorConfigEntity<TAppState = {}, TApplicationAccessConfig = {}> extends IBasicConnectorConfigEntity<TAppState>, IAccessConfigurationWrapper<TApplicationAccessConfig> {
}
/**
 * @stable [22.10.2018]
 */
export declare enum LayoutBuilderTypeEnum {
    VERTICAL = 0,
    HORIZONTAL = 1
}
export declare const LAYOUT_BUILDER_TYPES: {
    VERTICAL: LayoutBuilderTypeEnum;
    HORIZONTAL: LayoutBuilderTypeEnum;
};
export declare enum LayoutBuilderFactorsEnum {
    FACTOR_0_5 = 0,
    FACTOR_0_75 = 1,
    FACTOR_1 = 2,
    FACTOR_2 = 3,
    FACTOR_4 = 4,
    FACTOR_8 = 5
}
export declare const LAYOUT_BUILDER_FACTOR_TYPES: {
    FACTOR_0_5: LayoutBuilderFactorsEnum;
    FACTOR_0_75: LayoutBuilderFactorsEnum;
    FACTOR_1: LayoutBuilderFactorsEnum;
    FACTOR_2: LayoutBuilderFactorsEnum;
    FACTOR_4: LayoutBuilderFactorsEnum;
    FACTOR_8: LayoutBuilderFactorsEnum;
};
/**
 * @stable [22.10.2018]
 */
export declare type UniversalLayoutBuilderChildrenT<TNode> = IUniversalLayoutBuilderConfiguration<TNode> | TNode;
/**
 * @stable [22.10.2018]
 */
export interface IUniversalLayoutBuilderConfiguration<TNode> extends ILayoutWrapper<LayoutBuilderTypeEnum>, IStyleWrapper<IKeyValue>, IFullWrapper, IChildrenWrapper<Array<UniversalLayoutBuilderChildrenT<TNode>>>, IFactorWrapper<LayoutBuilderFactorsEnum> {
}
export interface IRnModalConfiguration extends IReactComponentConfiguration, IShadowStyleWrapper<IKeyValue>, IHasContentWrapperWrapper, ICenterAlignmentWrapper {
}
export interface IGridRowConfiguration extends IComponentConfiguration, IStringArrayExcludeTargetsClassesWrapper {
}
export interface IComponentConfiguration extends IReactComponentConfiguration, IWebComponentEntity {
}
export interface IUniversalMessageConfiguration extends IReactComponentConfiguration, IEmptyDataMessageWrapper, IErrorMessageWrapper, IEmptyMessageWrapper<React.ReactNode>, IBooleanEmptyDataWrapper {
}
export interface IRnDrawerConfiguration extends IReactComponentConfiguration, IContentWrapper {
}
export interface IRnDefaultLayoutContainerConfiguration extends IUniversalContainerEntity, IHeaderBackActionEnabledWrapper, IHeaderMenuActionEnabledWrapper, IDrawerContentWrapper, IHeaderContentWrapper, IHeaderActionIconStyleWrapper, IHeaderActionStyleWrapper, IHeaderActionStyleWrapper, IHeaderTitleStyleWrapper, IHeaderStyleWrapper, IContentStyleWrapper, IDrawerContentStyleWrapper, IUseDrawerWrapper, IUseHeaderWrapper {
}
/**
 * @stable [27.04.2018]
 */
export interface ICardConfiguration extends IComponentConfiguration, IReactOnClickWrapper, IRippableWrapper, IActionButtonsWrapper<React.ReactNode>, IActionIconsWrapper<React.ReactNode> {
}
/**
 * @deprecated
 */
export interface INavigationListItemConfiguration extends INavigationItemEntity {
}
/**
 * @stable [04.05.2018]
 */
export interface IDelayedChangesFieldPluginConfiguration extends IDelayTimeoutWrapper, IOnDelayWrapper {
}
/**
 * @stable [04.05.2018]
 */
export interface IBindDictionaryConfiguration extends IBindDictionaryWrapper, IOnEmptyDictionaryWrapper<IApiEntity>, IOnLoadDictionaryWrapper {
}
/**
 * @stable [31.07.2018]
 */
export interface IMenuConfiguration extends IComponentConfiguration, IMaxCountWrapper, IRenderToXWrapper, IRenderToYWrapper, IFilterPlaceholderWrapper, IMultiWrapper, IUseFilterWrapper, IWidthWrapper<number | (() => number)>, ICenteredMenuWrapper, IRendererWrapper<IMenuItemEntity>, IFilterWrapper<(valueToFilter: string, item: IMenuItemEntity) => boolean>, ITplFnWrapper<IMenuItemEntity>, IOnSelectWrapper<IMenuItemEntity>, IOnCloseWrapper, IOnFilterChangeWrapper<(query: string) => void> {
    remoteFilter?: boolean;
    overlayRendered?: boolean;
}
/**
 * @stable [13.09.2018]
 */
export declare enum ToolbarActionEnum {
    OPEN_FILTER = 0,
    CLEAR_FILTER = 1,
    REFRESH_DATA = 2,
    DOWNLOAD_DATA = 3
}
/**
 * @stable [15.05.2018]
 */
export interface IFieldActionConfiguration extends IClassNameWrapper, ITitleWrapper, IDisabledWrapper<boolean | (() => boolean)>, ITypeWrapper, IReactOnClickWrapper {
}
/**
 * @stable [18.05.2018]
 */
export interface IFilterActionConfiguration extends IClassNameWrapper, IDisabledWrapper, ITypeWrapper<ToolbarActionEnum> {
}
/**
 * @stable [18.05.2018]
 */
export interface IFilterConfiguration extends IActionsDisabledWrapper, INotUseFieldWrapper, IIconWrapper, IFullWrapper, IActionsWrapper<IFilterActionConfiguration[]>, IFieldConfigurationWrapper {
}
/**
 * @stable [18.05.2018]
 */
export interface IUniversalUIIconConfiguration extends IReactComponentConfiguration, IDisabledWrapper, ITypeWrapper, IClassNameWrapper, ISimpleWrapper, IReactOnClickWrapper {
}
/**
 * @stable [18.05.2018]
 */
export interface IUIIconConfiguration extends IUniversalUIIconConfiguration, IWebComponentEntity {
}
/**
 * @stable [18.05.2018]
 */
export declare type UniversalUIIconConfigurationT = IUniversalUIIconConfiguration | string;
/**
 * @stable [18.05.2018]
 */
export declare type UIIconConfigurationT = IUIIconConfiguration | string;
/**
 * @stable [08.08.2018]
 */
export interface ISubHeaderConfiguration extends IComponentConfiguration, IMoreOptionsWrapper<IMenuItemEntity[]>, IItemsWrapper<JSX.Element>, INavigationActionTypeWrapper, IOnNavigationActionClickWrapper, IOnMoreOptionsSelectWrapper<IMenuItemEntity>, ITitleRendererWrapper<JSX.Element>, ISubBorderWrapper {
}
/**
 * @stable [05.06.2018]
 */
export interface IFilterAndSorterConfiguration extends IFilterFnWrapper, ISorterFnWrapper {
}
