import { AnyT } from '../definitions.interface';
/**
 * @stable [16.09.2019]
 */
export declare const STORAGE_APP_STATE_KEY = "$$state";
export declare const STORAGE_APP_UUID_KEY: string;
export declare const STORAGE_APP_TOKEN_KEY: string;
/**
 * @stable [28.07.2019]
 */
export declare enum StorageTypesEnum {
    SESSION = 0,
    LOCAL = 1
}
/**
 * @stable [28.07.2019]
 */
export interface IStorage {
    set(key: string, value: AnyT): Promise<AnyT>;
    get?(key: string): Promise<AnyT>;
    remove?(key: string, noPrefix?: boolean): Promise<void>;
    each?(command: (o: AnyT, key: string) => void): void;
}
