"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
exports.FIRST_PAGE = 1;
exports.ONE_DOLLAR_VALUE = 1;
exports.DEFAULT_CURRENCY_PRECISION_VALUE = 2;
exports.DEFAULT_PAGE_SIZE = 50;
exports.DEFAULT_MAX_PAGE_SIZE = 1000000;
exports.DEFAULT_TIME_FROM = '00:00:00';
exports.DEFAULT_TIME_TO = '23:59:59';
exports.NEW_OPTION = 'new';
exports.UNDEF = void 0;
exports.UNDEF_SYMBOL = Symbol('UNDEF');
exports.CLEAR_DIRTY_CHANGES_VALUE = exports.UNDEF;
exports.ACTION_PREFIX = '$$-RAC-';
exports.UNIVERSAL_SELECTED_ELEMENT_SELECTOR = 'rac-universal-selected-element';
exports.UNIVERSAL_STICKY_ELEMENT_SELECTOR = 'rac-sticky-element';
exports.APPLICATION_PDF_FORMAT = 'application/pdf';
exports.IMAGE_JPG_FORMAT = 'image/jpg';
exports.IMAGE_JPEG_FORMAT = 'image/jpeg';
exports.IMAGE_PNG_FORMAT = 'image/png';
/**
 * @stable [15.09.2018]
 */
exports.DAYS_OF_WEEK = [
    { id: 0, name: 'Sunday' },
    { id: 1, name: 'Monday' },
    { id: 2, name: 'Tuesday' },
    { id: 3, name: 'Wednesday' },
    { id: 4, name: 'Thursday' },
    { id: 5, name: 'Friday' },
    { id: 6, name: 'Saturday' }
];
exports.DAYS_OF_WEEK_MAP = R.mergeAll(exports.DAYS_OF_WEEK.map(function (day) {
    var _a;
    return (_a = {}, _a[day.id] = true, _a);
}));
/**
 * Core fields
 */
exports.ID_FIELD_NAME = 'id'; /* @stable [02.07.2018] */
exports.FROM_DATE_FIELD_NAME = 'fromDate';
exports.TO_DATE_FIELD_NAME = 'toDate';
exports.FROM_TIME_FIELD_NAME = 'fromTime';
exports.TO_TIME_FIELD_NAME = 'toTime';
exports.TIME_FIELD_NAME = 'time';
exports.NAME_FIELD_NAME = 'name'; /* @stable [16.08.2018] */
exports.REGION_FIELD_NAME = 'region'; /* @stable [01.08.2018] */
exports.CITY_FIELD_NAME = 'city'; /* @stable [04.08.2018] */
/**
 * @stable [10.09.2019]
 */
var UniCodesEnum;
(function (UniCodesEnum) {
    UniCodesEnum["ARROW_RIGHT"] = "\u27F6";
    UniCodesEnum["DASH"] = "\u2014";
    UniCodesEnum["SPACE"] = " ";
})(UniCodesEnum = exports.UniCodesEnum || (exports.UniCodesEnum = {}));
/**
 * @deprecated
 */
exports.UNI_CODES = {
    dash: '\u2014',
    infinity: '\u221e',
    nDash: '\u2013',
    space: '\u0020',
    noBreakSpace: '\u00a0',
    arrowRight: '\u27f6',
    crarr: '\u21b5',
    lfloor: '\u230a',
};
//# sourceMappingURL=definitions.interface.js.map