import { Store } from 'redux';
import { INumberConverter } from '../converter';
import { ISettings } from '../settings';
import { IEnvironment, IStorage, ITransport } from '../definition';
import { IUIFactory } from '../component/factory/factory.interface';
import { IUniversalComponentClassEntity, UniversalComponentPluginFactoryT } from '../entities-definitions.interface';
import { TranslatorT } from '../translation';
/**
 * @stable [31.10.2018]
 * @returns {INumberConverter}
 */
export declare const getNumberConverter: () => INumberConverter;
/**
 * @stable [09.11.2018]
 * @returns {IUIFactory}
 */
export declare const getUiFactory: () => IUIFactory;
/**
 * @stable [21.08.2019]
 * @returns {Map<IUniversalComponentClassEntity, UniversalComponentPluginFactoryT>}
 */
export declare const getUiPlugins: () => Map<IUniversalComponentClassEntity<import("core/props-definitions.interface").IUniversalComponentProps, {}>, UniversalComponentPluginFactoryT>;
/**
 * @stable [15.11.2018]
 * @returns {TranslatorT}
 */
export declare const getTranslator: () => TranslatorT;
/**
 * @stable [29.07.2019]
 * @returns {ISettings}
 */
export declare const getSettings: () => ISettings;
/**
 * @stable [29.07.2019]
 * @returns {IStorage}
 */
export declare const getDatabaseStorage: () => IStorage;
/**
 * @stable [23.02.2019]
 * @returns {TApi}
 */
export declare const getApi: <TApi>() => TApi;
/**
 * @stable [11.09.2019]
 * @returns {Store<TState>}
 */
export declare const getStore: <TState>() => Store<TState>;
/**
 * @stable [15.09.2019]
 * @returns {ITransport}
 */
export declare const getTransport: () => ITransport;
/**
 * @stable [20.09.2019]
 * @returns {IEnvironment}
 */
export declare const getEnvironment: () => IEnvironment;
