"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var env_1 = require("../env");
var di_1 = require("../di");
var LogManager = /** @class */ (function () {
    function LogManager() {
    }
    LogManager_1 = LogManager;
    /**
     * @stable [11.08.2019]
     */
    LogManager.prototype.send = function (category, eventAction, payload) {
        try {
            var ga = window.ga;
            if (R.isNil(ga)) {
                return;
            }
            var state = this.store.getState();
            var user = state.user;
            var appVersion = env_1.ENV.appVersion;
            ga('send', {
                hitType: 'event',
                eventCategory: env_1.ENV.host + ":" + category,
                eventAction: eventAction,
                eventLabel: "" + (R.isNil(user) || R.isNil(user.id) ? '' : user.id + ":" + user.name + ":") + appVersion + ":" + this.dc.fromDateTimeToDateTime(new Date()) + this.getEventLabel(payload),
            });
        }
        catch (e) {
            LogManager_1.logger.error('[$LogManager][send] The system error has occurred:', e);
        }
    };
    /**
     * @stable [11.08.2019]
     * @param {AnyT} payload
     * @returns {string}
     */
    LogManager.prototype.getEventLabel = function (payload) {
        if (R.isNil(payload)) {
            return '';
        }
        try {
            return ":" + JSON.stringify(payload);
        }
        catch (e) {
            LogManager_1.logger.error('[$LogManager][getEventLabel] The system error has occurred:', e);
        }
    };
    var LogManager_1;
    LogManager.logger = ts_smart_logger_1.LoggerFactory.makeLogger('Transport');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], LogManager.prototype, "store", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DateConverter),
        __metadata("design:type", Object)
    ], LogManager.prototype, "dc", void 0);
    LogManager = LogManager_1 = __decorate([
        inversify_1.injectable()
    ], LogManager);
    return LogManager;
}());
exports.LogManager = LogManager;
//# sourceMappingURL=log-manager.service.js.map