import { AnyT } from '../../definitions.interface';
import { BaseStorage } from '../base-storage.service';
import { ISettings } from '../../settings';
import { StorageTypesEnum } from '../../definition';
export declare class DefaultStorage extends BaseStorage {
    private settingsProvider;
    private storageType?;
    /**
     * @stable [28.07.2019]
     * @param {string} prefix
     * @param {() => ISettings} settingsProvider
     * @param {StorageTypesEnum} storageType
     */
    constructor(prefix: string, settingsProvider: () => ISettings, storageType?: StorageTypesEnum);
    /**
     * @stable [28.07.2019]
     * @param {string} key
     * @param {AnyT} value
     * @returns {Promise<boolean>}
     */
    set(key: string, value: AnyT): Promise<boolean>;
    /**
     * @stable [28.07.2019]
     * @param {string} key
     * @returns {Promise<AnyT>}
     */
    get(key: string): Promise<AnyT>;
    /**
     * @stable [28.07.2019]
     * @param {string} key
     * @param {boolean} noPrefix
     * @returns {Promise<boolean>}
     */
    remove(key: string, noPrefix?: boolean): Promise<void>;
    /**
     * @stable [28.07.2019]
     * @param {(key: string, value: AnyT) => void} callback
     */
    each(callback: (key: string, value: AnyT) => void): void;
    /**
     * @stable [28.07.2019]
     * @returns {Storage}
     */
    private readonly storage;
}
