import { IMultiEntityStorageResult } from '../storage.interface';
import { IStorage } from '../../definition';
import { IMultiItemEntity, IMultiEntity } from '../../entities-definitions.interface';
export declare class MultiEntityStorage implements IStorage {
    private storage;
    private multiEntityProcessor;
    /**
     * @stable [30.07.2019]
     * @param {IStorage} storage
     * @param {(entity: IMultiItemEntity) => Promise<any>} multiEntityProcessor
     */
    constructor(storage: IStorage, multiEntityProcessor?: (entity: IMultiItemEntity) => Promise<any>);
    /**
     * @stable [30.07.2019]
     * @param {string} key
     * @param {IMultiEntity} entity
     * @returns {Promise<IMultiEntityStorageResult>}
     */
    set(key: string, entity: IMultiEntity): Promise<IMultiEntityStorageResult>;
    /**
     * @stable [30.07.2019]
     * @param {IMultiEntity} entity
     * @returns {Promise<AnyT[]>}
     */
    private add;
    /**
     * @stable [30.07.2019]
     * @param {IMultiEntity} entity
     * @returns {Promise<void[]>}
     */
    private clear;
}
