"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var di_1 = require("../../di");
var action_builder_1 = require("../../component/action.builder");
var untouched_list_middleware_1 = require("../middleware/untouched-list.middleware");
/**
 * @stable [31.08.2018]
 * @param {IUntouchedListMiddlewareConfig<TApplicationState>} config
 * @returns {() => void}
 */
function makeUntouchedListEffectsProxy(config) {
    var untouchedListMiddleware = untouched_list_middleware_1.makeUntouchedListMiddleware(config);
    var untouchedLazyLoadedListMiddleware = untouched_list_middleware_1.makeUntouchedLazyLoadedListMiddleware(config);
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            /**
             * @stable [31.08.2018]
             * @param {IEffectsAction} action
             * @param {TApplicationState} state
             * @returns {IEffectsAction}
             */
            Effects.prototype.$onConnectorInit = function (action, state) {
                return untouchedListMiddleware(action, state);
            };
            /**
             * @stable [31.08.2018]
             * @param {IEffectsAction} action
             * @param {TApplicationState} state
             * @returns {IEffectsAction}
             */
            Effects.prototype.$onTabActivate = function (action, state) {
                return untouchedLazyLoadedListMiddleware(action, state);
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ConnectorActionBuilder.buildInitActionType(config.listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Object)
            ], Effects.prototype, "$onConnectorInit", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.TabPanelActionBuilder.buildActivateActionType(config.listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Object)
            ], Effects.prototype, "$onTabActivate", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
}
exports.makeUntouchedListEffectsProxy = makeUntouchedListEffectsProxy;
//# sourceMappingURL=untouched-list-effects.proxy.js.map