import { IEditableApiEntity, IEnvironment } from '../definition';
import { IEntity } from '../definitions.interface';
import { INumberConverter } from '../converter';
import { ISettings } from '../settings';
import { ITransportRequestEntity, ITransport } from '../definition';
export declare class BaseTransport {
    protected readonly environment: IEnvironment;
    protected readonly nc: INumberConverter;
    protected readonly settings: ISettings;
    protected readonly transport: ITransport;
    /**
     * @stable [29.08.2019]
     * @param {StringNumberT} value
     * @param {(value: number) => number} converter
     * @returns {number}
     */
    protected prepareNumberValue: (value: string | number, converter?: (value: number) => number) => number;
    /**
     * @stable [10.08.2019]
     * @param {AnyT} value
     * @returns {AnyT}
     */
    protected prepareStringValue: (value: any) => any;
    /**
     * @stable [25.07.2019]
     * @param {string} value
     * @returns {string}
     */
    protected preparePhoneValue(value: string): string;
    /**
     * @stable [31.08.2019]
     * @param {ITransportRequestEntity} params
     */
    protected downloadFile(params: ITransportRequestEntity): void;
    /**
     * @stable [26.02.2019]
     * @param {IEditableApiEntity<TEntity extends IEntity>} entity
     * @returns {Promise<TEntity extends IEntity>}
     */
    protected doSaveEntity<TEntity extends IEntity, TResult = TEntity>(entity: IEditableApiEntity<TEntity>): Promise<TResult>;
}
