import { IKeyValue } from '../definitions.interface';
import { ITransport, ITransportRequestEntity } from '../definition';
export declare class Transport implements ITransport {
    private static readonly logger;
    private readonly logManager;
    private readonly store;
    private readonly transportFactory;
    private readonly requestPayloadFactory;
    /**
     * @stable [26.02.2019]
     */
    constructor();
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} requestEntity
     * @returns {IKeyValue}
     */
    makeRequestData(requestEntity: ITransportRequestEntity): IKeyValue;
    /**
     * @stable [28.08.2019]
     * @param {ITransportRequestEntity} req
     * @returns {Promise<TResponse>}
     */
    request<TResponse>(req: ITransportRequestEntity): Promise<TResponse>;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     */
    cancelRequest(req: ITransportRequestEntity): void;
    /**
     * @stable [17.08.2018]
     * @param {ITransportRequestEntity} req
     */
    private onRequestCancel;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {ITransportResponseEntity} responseEntity
     */
    private onRequestError;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {ITransportResponseEntity} responseEntity
     */
    private onRequestDone;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportResponseEntity}
     */
    private toResponseMetaEntity;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    private toOperationId;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportFactory}
     */
    private getTransportFactory;
    /**
     * @stable [11.08.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    private toLogEventName;
}
