"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../di");
var util_1 = require("../util");
var transport_reducer_interface_1 = require("./transport-reducer.interface");
var env_1 = require("../env");
var definition_1 = require("../definition");
var Transport = /** @class */ (function () {
    /**
     * @stable [26.02.2019]
     */
    function Transport() {
        env_1.ENV.setVariable(definition_1.EnvironmentVariablesEnum.TRANSPORT, this);
    }
    Transport_1 = Transport;
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} requestEntity
     * @returns {IKeyValue}
     */
    Transport.prototype.makeRequestData = function (requestEntity) {
        return this.requestPayloadFactory.makeRequestData(requestEntity);
    };
    /**
     * @stable [28.08.2019]
     * @param {ITransportRequestEntity} req
     * @returns {Promise<TResponse>}
     */
    Transport.prototype.request = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var responseFactoryEntity, e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.cancelRequest(req); // Try cancel the same request automatically
                        this.store.dispatch({ type: transport_reducer_interface_1.TRANSPORT_REQUEST_ACTION_TYPE, data: this.toResponseMetaEntity(req) });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getTransportFactory(req).request(req, function (payload) {
                                return (_this.logManager.send(definition_1.TransportEventsEnum.TRANSPORT, _this.toLogEventName(req), payload), payload);
                            })];
                    case 2:
                        responseFactoryEntity = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        if (e_1.cancelled) {
                            Transport_1.logger.debug('[$Transport][request] A user has canceled the request:', e_1);
                            this.onRequestCancel(req);
                            return [2 /*return*/, null];
                        }
                        else {
                            Transport_1.logger.error('[$Transport][request] The system error has occurred:', e_1);
                            this.onRequestError(req, e_1);
                            throw e_1;
                        }
                        return [3 /*break*/, 4];
                    case 4:
                        if (responseFactoryEntity.error) {
                            Transport_1.logger.warn('[$Transport][request] The business logic error has occurred:', responseFactoryEntity);
                            this.onRequestError(req, responseFactoryEntity);
                            throw responseFactoryEntity;
                        }
                        else {
                            this.onRequestDone(req, responseFactoryEntity);
                            return [2 /*return*/, responseFactoryEntity.result];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     */
    Transport.prototype.cancelRequest = function (req) {
        this.getTransportFactory(req).cancelRequest(req);
    };
    /**
     * @stable [17.08.2018]
     * @param {ITransportRequestEntity} req
     */
    Transport.prototype.onRequestCancel = function (req) {
        this.store.dispatch({ type: transport_reducer_interface_1.TRANSPORT_REQUEST_CANCEL_ACTION_TYPE, data: this.toResponseMetaEntity(req) });
    };
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {ITransportResponseEntity} responseEntity
     */
    Transport.prototype.onRequestError = function (req, responseEntity) {
        this.logManager.send(definition_1.TransportEventsEnum.TRANSPORT_ERROR, this.toLogEventName(req), responseEntity);
        this.store.dispatch({
            type: transport_reducer_interface_1.TRANSPORT_REQUEST_ERROR_ACTION_TYPE,
            data: util_1.toType(__assign({}, this.toResponseMetaEntity(req), responseEntity)),
        });
    };
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {ITransportResponseEntity} responseEntity
     */
    Transport.prototype.onRequestDone = function (req, responseEntity) {
        this.store.dispatch({
            type: transport_reducer_interface_1.TRANSPORT_REQUEST_DONE_ACTION_TYPE,
            data: util_1.toType(__assign({}, this.toResponseMetaEntity(req), responseEntity)),
        });
    };
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportResponseEntity}
     */
    Transport.prototype.toResponseMetaEntity = function (req) {
        return util_1.notNilValuesFilter({
            name: req.name,
            operationId: this.toOperationId(req),
        });
    };
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    Transport.prototype.toOperationId = function (req) {
        return util_1.ifNotNilThanValue(req.operation, function (operation) { return operation.id; });
    };
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportFactory}
     */
    Transport.prototype.getTransportFactory = function (req) {
        return req.transportFactory || this.transportFactory;
    };
    /**
     * @stable [11.08.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    Transport.prototype.toLogEventName = function (req) {
        return util_1.coalesce(req.name, req.path, req.url);
    };
    var Transport_1;
    Transport.logger = ts_smart_logger_1.LoggerFactory.makeLogger('Transport');
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.LogManager),
        __metadata("design:type", Object)
    ], Transport.prototype, "logManager", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], Transport.prototype, "store", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportFactory),
        __metadata("design:type", Object)
    ], Transport.prototype, "transportFactory", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportRequestPayloadFactory),
        __metadata("design:type", Object)
    ], Transport.prototype, "requestPayloadFactory", void 0);
    Transport = Transport_1 = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], Transport);
    return Transport;
}());
exports.Transport = Transport;
//# sourceMappingURL=transport.service.js.map