"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../util");
/**
 * @stable [30.05.2019]
 * @param {IEffectsAction} action
 * @returns {boolean}
 */
exports.isSelectedEntityInitiallyNotSelected = function (action) {
    return util_1.ifNotNilThanValue(action.initialData, function (selectedWrapper) { return R.isNil(selectedWrapper.selected); }, false);
};
/**
 * @stable [30.05.2019]
 * @param {IEffectsAction} action
 * @returns {TEntity extends IEntity}
 */
exports.getSelectedEntityFromAction = function (action) {
    return util_1.nvl(util_1.toType(action.data).selected, util_1.toType(action.initialData).selected);
};
//# sourceMappingURL=action.js.map