import { IKeyValue } from '../definitions.interface';
/**
 * @stable [16.12.2018]
 * @param {number} length
 * @returns {AnyT[]}
 */
export declare const generateArray: (length: number) => any[];
/**
 * @stable [19.11.2018]
 * @param {number[]} array
 * @returns {number}
 */
export declare const arrayMinValue: (array: number[]) => number;
/**
 * @stable [22.11.2018]
 * @param {number[]} array
 * @returns {number}
 */
export declare const arrayNextMinNegativeValue: (array: number[]) => number;
/**
 * @stable [19.12.2018]
 * @param {TValue[]} array
 * @returns {boolean}
 */
export declare const isArrayNotEmpty: <TValue>(array: TValue[]) => boolean;
/**
 * @stable [28.01.2019]
 * @param {TValue[]} array
 * @param {number} limit
 * @returns {TValue[]}
 */
export declare const subArray: <TValue>(array: TValue[], limit?: number) => TValue[];
/**
 * @stable [26.07.2019]
 * @param {TValue[]} array
 * @param {TValue} initialItem
 * @param {(previousItem: TValue, initialItem: TValue) => TValue} mergedItemFactory
 * @param {(itm1: TValue, itm2: TValue) => boolean} predicate
 * @returns {TValue[]}
 */
export declare const mergeArrayItem: <TValue extends IKeyValue>(array: TValue[], initialItem: TValue, mergedItemFactory: (previousItem: TValue) => TValue, predicate: (itm1: TValue, itm2: TValue) => boolean) => TValue[];
/**
 * @stable [31.08.2019]
 * @param {AnyT} values
 * @returns {boolean}
 */
export declare const areArrayValuesNotNil: (...values: any[]) => boolean;
