import { AnyT } from '../definitions.interface';
/**
 * @stable [25.10.2018]
 * @param {AnyT} condition
 * @param {string | (() => string)} result
 * @returns {string}
 */
export declare const orEmpty: (condition: any, result: string | (() => string)) => string;
export declare function orNull<TResult>(condition: AnyT, result: TResult | (() => TResult)): TResult;
export declare function orUndef<TResult>(condition: AnyT, result: TResult | (() => TResult)): TResult;
/**
 * @deprecated
 */
export declare function orDefault<TResult1, TResult2>(cond: boolean, result1: TResult1 | (() => TResult1), result2: TResult2 | (() => TResult2)): TResult1 | TResult2;
/**
 * @stable [10.08.2019]
 * @param {TValue} value
 * @param {(value: TValue) => TResult} callback
 * @param {any} defaultValue
 * @returns {TResult}
 */
export declare const ifNotNilThanValue: <TValue, TResult>(value: TValue, callback: (value: TValue) => TResult, defaultValue?: any) => TResult;
/**
 * @stable [30.07.2019]
 * @param {TValue} value
 * @param {(value: TValue) => TResult} callback
 * @param {any} defaultValue
 * @returns {TResult}
 */
export declare const ifNilThanValue: <TValue, TResult>(value: TValue, callback: (value: TValue) => TResult, defaultValue?: any) => TResult;
/**
 * @stable [16.09.2019]
 * @param {TValue} value
 * @param {(value: TValue) => TResult} callback
 * @param {any} defaultValue
 * @returns {TResult}
 */
export declare const ifNotEmptyThanValue: <TValue, TResult>(value: TValue, callback: (value: TValue) => TResult, defaultValue?: any) => TResult;
/**
 * @stable [15.09.2019]
 * @param {boolean} value
 * @param {(value: boolean) => TResult} callback
 * @param {any} defaultValue
 * @returns {TResult}
 */
export declare const ifNotFalseThanValue: <TResult>(value: boolean, callback: (value: boolean) => TResult, defaultValue?: any) => TResult;
/**
 * @stable [29.03.2019]
 * @param {boolean} value
 * @param {(value: boolean) => TResult} callback
 * @param {any} defaultValue
 * @returns {TResult}
 */
export declare const ifNotTrueThanValue: <TResult>(value: boolean, callback: (value: boolean) => TResult, defaultValue?: any) => TResult;
/**
 * @stable [26.06.2019]
 * @param {StringNumberT} value
 * @returns {StringNumberT}
 */
export declare const ifEmptyThanNull: (value: string | number) => string | number;
