import { IEntity, IKeyValue } from '../definitions.interface';
/**
 * @stable [27.08.2019]
 * @param {EntityIdT} key
 * @returns {string}
 */
export declare const dynamicFieldName: (key: string | number) => string;
/**
 * @stable [28.08.2019]
 * @param {TEntity} object
 * @param {EntityIdT} key
 * @returns {AnyT}
 */
export declare const dynamicFieldValue: <TEntity extends IEntity>(object: TEntity, key: string | number) => any;
/**
 * @stable [28.08.2019]
 * @param {TEntity[]} array
 * @param {(itm: TEntity) => EntityIdT} keyAccessor
 * @param {(itm: TEntity) => EntityIdT} valueAccessor
 * @returns {IKeyValue}
 */
export declare const fromDynamicFieldsArray: <TEntity extends string | number | IEntity>(array: TEntity[], keyAccessor: (itm: TEntity) => string | number, valueAccessor: (itm: TEntity) => string | number) => IKeyValue;
/**
 * @stable [28.08.2019]
 * @param {EntityIdT[]} array
 * @param {(itm: EntityIdT) => EntityIdT} valueAccessor
 * @returns {IKeyValue}
 */
export declare const fromDynamicFieldsIdsArray: (array: (string | number)[], valueAccessor: (itm: string | number) => string | number) => IKeyValue;
/**
 * @stable [31.08.2019]
 * @param {AnyT} value
 * @returns {AnyT}
 */
export declare const toAlwaysDirtyFieldValue: (value: any) => any;
