"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mapper_1 = require("./mapper");
describe('util/mapper', function () {
    describe('mapExtendedEntity', function () {
        it('test1', function () {
            var extendedEntity = mapper_1.mapExtendedEntity({ name: 'name1', id: 100 }, { changes: { name: 'name2' } });
            expect(extendedEntity).toEqual({
                entity: { name: 'name2', id: 100 },
                entityId: 100,
                newEntity: false,
                originalEntity: { name: 'name1', id: 100 },
            });
        });
        it('test2', function () {
            var extendedEntity = mapper_1.mapExtendedEntity({ name: 'name1' }, { changes: { name: 'name2' } });
            expect(extendedEntity).toEqual({
                entity: { name: 'name2' },
                newEntity: true,
                originalEntity: { name: 'name1' },
            });
        });
        it('test3', function () {
            var extendedEntity = mapper_1.mapExtendedEntity({ name: 'name1' });
            expect(extendedEntity).toEqual({
                entity: { name: 'name1' },
                newEntity: true,
                originalEntity: { name: 'name1' },
            });
        });
        it('test4', function () {
            var extendedEntity = mapper_1.mapExtendedEntity(null);
            expect(extendedEntity).toEqual({
                entity: {},
                newEntity: true,
            });
        });
        it('test5', function () {
            var extendedEntity = mapper_1.mapExtendedEntity(undefined);
            expect(extendedEntity).toEqual({
                entity: {},
                newEntity: true,
            });
        });
    });
});
//# sourceMappingURL=mapper.spec.js.map