"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var event_1 = require("./event");
var env_1 = require("../env");
var cond_1 = require("./cond");
var type_1 = require("./type");
/**
 * @stable [31.08.2019]
 * @param {() => void} handler
 * @param {boolean} canAttachHandler
 * @returns {React.DetailedHTMLProps<React.HTMLAttributes<HTMLElement>, HTMLElement>}
 */
exports.handlerPropsFactory = function (handler, canAttachHandler) {
    if (canAttachHandler === void 0) { canAttachHandler = true; }
    return (__assign({}, cond_1.ifNotFalseThanValue(canAttachHandler && type_1.isFn(handler) && env_1.ENV.mobilePlatform, function () { return ({
        onClick: event_1.cancelEvent,
        onDoubleClick: event_1.cancelEvent,
        onTouchStart: function (e) {
            event_1.cancelEvent(e, true);
            handler();
        },
    }); }), cond_1.ifNotFalseThanValue(canAttachHandler && type_1.isFn(handler) && !env_1.ENV.mobilePlatform, function () { return ({
        onClick: function (e) {
            event_1.cancelEvent(e);
            handler();
        },
    }); })));
};
//# sourceMappingURL=props.js.map