import { IKeyValue, IDataWrapper, IValidWrapper } from '../definitions.interface';
/**
 * @stable [28.01.2019]
 */
export declare enum ValidatorRuleEnum {
    NOT_NULL_NUMBER = 0,
    OPTIONAL_NUMBER = 1,
    NOT_EMPTY_STRING = 2
}
/**
 * @stable [28.01.2019]
 */
interface IValidationResultEntity extends IValidWrapper, IDataWrapper<Record<string, Record<ValidatorRuleEnum, boolean>>> {
}
/**
 * @stable [28.01.2019]
 * @param value
 * @returns {boolean}
 */
export declare const notNullNumber: (value: any) => boolean;
/**
 * @stable [28.01.2019]
 * @param value
 * @returns {boolean}
 */
export declare const notNullString: (value: any) => boolean;
/**
 * @stable [28.01.2019]
 * @param value
 * @returns {boolean}
 */
export declare const optionalNumber: (value: any) => boolean;
/**
 * @stable [28.01.2019]
 * @param {AnyT} value
 * @returns {boolean}
 */
export declare const notEmptyString: (value: any) => boolean;
/**
 * @stable [28.01.2019]
 */
export declare const ValidationRules: {
    [ValidatorRuleEnum.NOT_NULL_NUMBER]: (value: any) => boolean;
    [ValidatorRuleEnum.OPTIONAL_NUMBER]: (value: any) => boolean;
    [ValidatorRuleEnum.NOT_EMPTY_STRING]: (value: any) => boolean;
};
/**
 * @stable [28.01.2019]
 * @param {Record<string, ValidatorRuleEnum[]>} payloads
 * @param {IKeyValue} checkedObject
 * @returns {IValidationResultEntity}
 */
export declare const validate: (payloads: Record<string, ValidatorRuleEnum[]>, checkedObject: IKeyValue) => IValidationResultEntity;
export {};
